`line 1 "C:\simulation_bench_mark\usb11\usb1_funct\rtl\verilog\usb1_utmi_if.v"





























































`line 1 "C:\simulation_bench_mark\usb11\usb1_funct\rtl\verilog\usb1_defines.v"





































































`line 1 "C:\simulation_bench_mark\usb11\generic_fifos\generic_fifos\rtl\verilog\timescale.v"
`timescale 1ns / 100ps

`line 70 "C:\simulation_bench_mark\usb11\usb1_defines.v"

















































































`line 62 "C:\simulation_bench_mark\usb11\usb1_funct\rtl\verilog\usb1_utmi_if.v"


module usb1_utmi_if( 
		phy_clk, rst,
		DataOut, TxValid, TxReady,
		RxValid, RxActive, RxError, DataIn,

		
		rx_data, rx_valid, rx_active, rx_err,
		tx_data, tx_valid, tx_valid_last, tx_ready,
		tx_first

		);

input		phy_clk;
input		rst;

output	[7:0]	DataOut;
output		TxValid;
input		TxReady;

input	[7:0]	DataIn;
input		RxValid;
input		RxActive;
input		RxError;


output	[7:0]	rx_data;
output		rx_valid, rx_active, rx_err;
input	[7:0]	tx_data;
input		tx_valid;
input		tx_valid_last;
output		tx_ready;
input		tx_first;





reg	[7:0]	rx_data;
reg		rx_valid, rx_active, rx_err;
reg	[7:0]	DataOut;
reg		tx_ready;
reg		TxValid;












always @(posedge phy_clk or negedge rst)
	if(!rst)	rx_valid <= #1 1'b0;
	else		rx_valid <= #1 RxValid;

always @(posedge phy_clk or negedge rst)
	if(!rst)	rx_active <= #1 1'b0;
	else		rx_active <= #1 RxActive;

always @(posedge phy_clk or negedge rst)
	if(!rst)	rx_err <= #1 1'b0;
	else		rx_err <= #1 RxError;

always @(posedge phy_clk)
		rx_data <= #1 DataIn;






always @(posedge phy_clk)
	if(TxReady | tx_first)	DataOut <= #1 tx_data;

always @(posedge phy_clk)
	tx_ready <= #1 TxReady;

always @(posedge phy_clk or negedge rst)
	if(!rst)	TxValid <= #1 1'b0;
	else
	TxValid <= #1 tx_valid | tx_valid_last | (TxValid & !TxReady);

endmodule



`line 1 "C:\simulation_bench_mark\usb11\usb1_funct\rtl\verilog\usb1_core.v"


































































`line 1 "C:\simulation_bench_mark\usb11\usb1_funct\rtl\verilog\usb1_defines.v"





































































`line 1 "C:\simulation_bench_mark\usb11\generic_fifos\generic_fifos\rtl\verilog\timescale.v"
`timescale 1ns / 100ps

`line 70 "C:\simulation_bench_mark\usb11\usb1_defines.v"

















































































`line 67 "C:\simulation_bench_mark\usb11\usb1_funct\rtl\verilog\usb1_core.v"







































































module usb1_core(clk_i, rst_i,

		
		tx_dp, tx_dn, tx_oe,
		rx_d, rx_dp, rx_dn,

		
		phy_tx_mode, usb_rst, 

		
		dropped_frame, misaligned_frame,
		crc16_err,

		
		v_set_int, v_set_feature, wValue,
		wIndex, vendor_data,

		
		usb_busy, ep_sel,

		
		ep1_cfg,
		ep1_din,  ep1_we, ep1_full,
		ep1_dout, ep1_re, ep1_empty,
		ep1_bf_en, ep1_bf_size,

		ep2_cfg,
		ep2_din,  ep2_we, ep2_full,
		ep2_dout, ep2_re, ep2_empty,
		ep2_bf_en, ep2_bf_size,

		ep3_cfg,
		ep3_din,  ep3_we, ep3_full,
		ep3_dout, ep3_re, ep3_empty,
		ep3_bf_en, ep3_bf_size,

		ep4_cfg,
		ep4_din,  ep4_we, ep4_full,
		ep4_dout, ep4_re, ep4_empty,
		ep4_bf_en, ep4_bf_size,

		ep5_cfg,
		ep5_din,  ep5_we, ep5_full,
		ep5_dout, ep5_re, ep5_empty,
		ep5_bf_en, ep5_bf_size,

		ep6_cfg,
		ep6_din,  ep6_we, ep6_full,
		ep6_dout, ep6_re, ep6_empty,
		ep6_bf_en, ep6_bf_size,

		ep7_cfg,
		ep7_din,  ep7_we, ep7_full,
		ep7_dout, ep7_re, ep7_empty,
		ep7_bf_en, ep7_bf_size

		); 		

input		clk_i;
input		rst_i;

output		tx_dp, tx_dn, tx_oe;
input		rx_d, rx_dp, rx_dn;

input		phy_tx_mode;
output		usb_rst;
output		dropped_frame, misaligned_frame;
output		crc16_err;

output		v_set_int;
output		v_set_feature;
output	[15:0]	wValue;
output	[15:0]	wIndex;
input	[15:0]	vendor_data;

output		usb_busy;
output	[3:0]	ep_sel;


input	[13:0]	ep1_cfg;
input	[7:0]	ep1_din;
output	[7:0]	ep1_dout;
output		ep1_we, ep1_re;
input		ep1_empty, ep1_full;
input		ep1_bf_en;
input	[6:0]	ep1_bf_size;

input	[13:0]	ep2_cfg;
input	[7:0]	ep2_din;
output	[7:0]	ep2_dout;
output		ep2_we, ep2_re;
input		ep2_empty, ep2_full;
input		ep2_bf_en;
input	[6:0]	ep2_bf_size;

input	[13:0]	ep3_cfg;
input	[7:0]	ep3_din;
output	[7:0]	ep3_dout;
output		ep3_we, ep3_re;
input		ep3_empty, ep3_full;
input		ep3_bf_en;
input	[6:0]	ep3_bf_size;

input	[13:0]	ep4_cfg;
input	[7:0]	ep4_din;
output	[7:0]	ep4_dout;
output		ep4_we, ep4_re;
input		ep4_empty, ep4_full;
input		ep4_bf_en;
input	[6:0]	ep4_bf_size;

input	[13:0]	ep5_cfg;
input	[7:0]	ep5_din;
output	[7:0]	ep5_dout;
output		ep5_we, ep5_re;
input		ep5_empty, ep5_full;
input		ep5_bf_en;
input	[6:0]	ep5_bf_size;

input	[13:0]	ep6_cfg;
input	[7:0]	ep6_din;
output	[7:0]	ep6_dout;
output		ep6_we, ep6_re;
input		ep6_empty, ep6_full;
input		ep6_bf_en;
input	[6:0]	ep6_bf_size;

input	[13:0]	ep7_cfg;
input	[7:0]	ep7_din;
output	[7:0]	ep7_dout;
output		ep7_we, ep7_re;
input		ep7_empty, ep7_full;
input		ep7_bf_en;
input	[6:0]	ep7_bf_size;







wire	[7:0]	DataOut;
wire		TxValid;
wire		TxReady;
wire	[7:0]	DataIn;
wire		RxValid;
wire		RxActive;
wire		RxError;
wire	[1:0]	LineState;

wire	[7:0]	rx_data;
wire		rx_valid, rx_active, rx_err;
wire	[7:0]	tx_data;
wire		tx_valid;
wire		tx_ready;
wire		tx_first;
wire		tx_valid_last;


wire	[6:0]	funct_adr;	
wire	[3:0]	ep_sel;		
wire		crc16_err;	
wire		int_to_set;	
wire		int_seqerr_set;	
wire	[31:0]	frm_nat;	
wire		nse_err;	
wire		pid_cs_err;	
wire		crc5_err;	

reg	[7:0]	tx_data_st;
wire	[7:0]	rx_data_st;
reg	[13:0]	cfg;
reg		ep_empty;
reg		ep_full;
wire	[7:0]	rx_size;
wire		rx_done;

wire	[7:0]	ep0_din;
wire	[7:0]	ep0_dout;
wire		ep0_re, ep0_we;
wire	[13:0]	ep0_cfg;
wire	[7:0]	ep0_size;
wire	[7:0]	ep0_ctrl_dout, ep0_ctrl_din;
wire		ep0_ctrl_re, ep0_ctrl_we;
wire	[3:0]	ep0_ctrl_stat;

wire		ctrl_setup, ctrl_in, ctrl_out;
wire		send_stall;
wire		token_valid;
reg		rst_local;		
wire		dropped_frame;
wire		misaligned_frame;
wire		v_set_int;
wire		v_set_feature;
wire	[15:0]	wValue;
wire	[15:0]	wIndex;

reg		ep_bf_en;
reg	[6:0]	ep_bf_size;
wire	[6:0]	rom_adr;
wire	[7:0]	rom_data;







assign ep0_cfg =  14'b10_100_000000000 | ep0_size;

always @(posedge clk_i)
	rst_local <= #1 rst_i & ~usb_rst;






usb_phy phy(
		.clk(			clk_i			),
		.rst(			rst_i			),	
		.phy_tx_mode(		phy_tx_mode		),
		.usb_rst(		usb_rst			),

		
		.rxd(			rx_d			),
		.rxdp(			rx_dp			),
		.rxdn(			rx_dn			),
		.txdp(			tx_dp			),
		.txdn(			tx_dn			),
		.txoe(			tx_oe			),

		
		.DataIn_o(		DataIn			),
		.RxValid_o(		RxValid			),
		.RxActive_o(		RxActive		),
		.RxError_o(		RxError			),
		.DataOut_i(		DataOut			),
		.TxValid_i(		TxValid			),
		.TxReady_o(		TxReady			),
		.LineState_o(		LineState		)
		);


usb1_utmi_if	u0(
		.phy_clk(		clk_i			),
		.rst(			rst_local		),
		.DataOut(		DataOut			),
		.TxValid(		TxValid			),
		.TxReady(		TxReady			),
		.RxValid(		RxValid			),
		.RxActive(		RxActive		),
		.RxError(		RxError			),
		.DataIn(		DataIn			),
		.rx_data(		rx_data			),
		.rx_valid(		rx_valid		),
		.rx_active(		rx_active		),
		.rx_err(		rx_err			),
		.tx_data(		tx_data			),
		.tx_valid(		tx_valid		),
		.tx_valid_last(		tx_valid_last		),
		.tx_ready(		tx_ready		),
		.tx_first(		tx_first		)
		);


usb1_pl  u1(	.clk(			clk_i			),
		.rst(			rst_local		),
		.rx_data(		rx_data			),
		.rx_valid(		rx_valid		),
		.rx_active(		rx_active		),
		.rx_err(		rx_err			),
		.tx_data(		tx_data			),
		.tx_valid(		tx_valid		),
		.tx_valid_last(		tx_valid_last		),
		.tx_ready(		tx_ready		),
		.tx_first(		tx_first		),
		.tx_valid_out(		TxValid			),
		.token_valid(		token_valid		),
		.fa(			funct_adr		),
		.ep_sel(		ep_sel			),
		.x_busy(		usb_busy		),
		.int_crc16_set(		crc16_err		),
		.int_to_set(		int_to_set		),
		.int_seqerr_set(	int_seqerr_set		),
		.frm_nat(		frm_nat			),
		.pid_cs_err(		pid_cs_err		),
		.nse_err(		nse_err			),
		.crc5_err(		crc5_err		),
		.rx_size(		rx_size			),
		.rx_done(		rx_done			),
		.ctrl_setup(		ctrl_setup		),
		.ctrl_in(		ctrl_in			),
		.ctrl_out(		ctrl_out		),
		.ep_bf_en(		ep_bf_en		),
		.ep_bf_size(		ep_bf_size		),
		.dropped_frame(		dropped_frame		),
		.misaligned_frame(	misaligned_frame	),
		.csr(			cfg			),
		.tx_data_st(		tx_data_st		),
		.rx_data_st(		rx_data_st		),
		.idma_re(		idma_re			),
		.idma_we(		idma_we			),
		.ep_empty(		ep_empty		),
		.ep_full(		ep_full			),
		.send_stall(		send_stall		)
		);

usb1_ctrl  u4(	.clk(			clk_i			),
		.rst(			rst_local		),

		.rom_adr(		rom_adr			),
		.rom_data(		rom_data		),

		.ctrl_setup(		ctrl_setup		),
		.ctrl_in(		ctrl_in			),
		.ctrl_out(		ctrl_out		),

		.ep0_din(		ep0_ctrl_dout		),
		.ep0_dout(		ep0_ctrl_din		),
		.ep0_re(		ep0_ctrl_re		),
		.ep0_we(		ep0_ctrl_we		),
		.ep0_stat(		ep0_ctrl_stat		),
		.ep0_size(		ep0_size		),

		.send_stall(		send_stall		),
		.frame_no(		frm_nat[26:16]		),
		.funct_adr(		funct_adr 		),
		.configured(					),
		.halt(						),

		.v_set_int(		v_set_int		),
		.v_set_feature(		v_set_feature		),
		.wValue(		wValue			),
		.wIndex(		wIndex			),
		.vendor_data(		vendor_data		)
		);


usb1_rom1 rom1(	.clk(		clk_i		),
		.adr(		rom_adr		),
		.dout(		rom_data	)
		);


generic_fifo_sc_a #(8,6,0) u10(
		.clk(			clk_i			),
		.rst(			rst_i			),
		.clr(			usb_rst			),
		.din(			rx_data_st		),
		.we(			ep0_we			),
		.dout(			ep0_ctrl_dout		),
		.re(			ep0_ctrl_re		),
		.full_r(					),
		.empty_r(					),
		.full(			ep0_full		),
		.empty(			ep0_ctrl_stat[1]	),
		.full_n(					),
		.empty_n(					),
		.full_n_r(					),
		.empty_n_r(					),
		.level(						)
		);

generic_fifo_sc_a #(8,6,0) u11(
		.clk(			clk_i			),
		.rst(			rst_i			),
		.clr(			usb_rst			),
		.din(			ep0_ctrl_din		),
		.we(			ep0_ctrl_we		),
		.dout(			ep0_dout		),
		.re(			ep0_re			),
		.full_r(					),
		.empty_r(					),
		.full(			ep0_ctrl_stat[2]	),
		.empty(			ep0_empty		),
		.full_n(					),
		.empty_n(					),
		.full_n_r(					),
		.empty_n_r(					),
		.level(						)
		);






always @(ep_sel or ep0_cfg or ep1_cfg or ep2_cfg or ep3_cfg or
		ep4_cfg or ep5_cfg or ep6_cfg or ep7_cfg)
	case(ep_sel)	
	   4'h0:	cfg = ep0_cfg;
	   4'h1:	cfg = ep1_cfg;
	   4'h2:	cfg = ep2_cfg;
	   4'h3:	cfg = ep3_cfg;
	   4'h4:	cfg = ep4_cfg;
	   4'h5:	cfg = ep5_cfg;
	   4'h6:	cfg = ep6_cfg;
	   4'h7:	cfg = ep7_cfg;
	endcase


always @(posedge clk_i)
	case(ep_sel)	
	   4'h0:	tx_data_st <= #1 ep0_dout;
	   4'h1:	tx_data_st <= #1 ep1_din;
	   4'h2:	tx_data_st <= #1 ep2_din;
	   4'h3:	tx_data_st <= #1 ep3_din;
	   4'h4:	tx_data_st <= #1 ep4_din;
	   4'h5:	tx_data_st <= #1 ep5_din;
	   4'h6:	tx_data_st <= #1 ep6_din;
	   4'h7:	tx_data_st <= #1 ep7_din;
	endcase


always @(posedge clk_i)
	case(ep_sel)	
	   4'h0:	ep_empty <= #1 ep0_empty;
	   4'h1:	ep_empty <= #1 ep1_empty;
	   4'h2:	ep_empty <= #1 ep2_empty;
	   4'h3:	ep_empty <= #1 ep3_empty;
	   4'h4:	ep_empty <= #1 ep4_empty;
	   4'h5:	ep_empty <= #1 ep5_empty;
	   4'h6:	ep_empty <= #1 ep6_empty;
	   4'h7:	ep_empty <= #1 ep7_empty;
	endcase


always @(ep_sel or ep0_full or ep1_full or ep2_full or ep3_full or
		ep4_full or ep5_full or ep6_full or ep7_full)
	case(ep_sel)	
	   4'h0:	ep_full = ep0_full;
	   4'h1:	ep_full = ep1_full;
	   4'h2:	ep_full = ep2_full;
	   4'h3:	ep_full = ep3_full;
	   4'h4:	ep_full = ep4_full;
	   4'h5:	ep_full = ep5_full;
	   4'h6:	ep_full = ep6_full;
	   4'h7:	ep_full = ep7_full;
	endcase

always @(posedge clk_i)
	case(ep_sel)	
	   4'h0:	ep_bf_en = 1'b0;
	   4'h1:	ep_bf_en = ep1_bf_en;
	   4'h2:	ep_bf_en = ep2_bf_en;
	   4'h3:	ep_bf_en = ep3_bf_en;
	   4'h4:	ep_bf_en = ep4_bf_en;
	   4'h5:	ep_bf_en = ep5_bf_en;
	   4'h6:	ep_bf_en = ep6_bf_en;
	   4'h7:	ep_bf_en = ep7_bf_en;
	endcase

always @(posedge clk_i)
	case(ep_sel)	
	   4'h1:	ep_bf_size = ep1_bf_size;
	   4'h2:	ep_bf_size = ep2_bf_size;
	   4'h3:	ep_bf_size = ep3_bf_size;
	   4'h4:	ep_bf_size = ep4_bf_size;
	   4'h5:	ep_bf_size = ep5_bf_size;
	   4'h6:	ep_bf_size = ep6_bf_size;
	   4'h7:	ep_bf_size = ep7_bf_size;
	endcase

assign ep1_dout = rx_data_st;
assign ep2_dout = rx_data_st;
assign ep3_dout = rx_data_st;
assign ep4_dout = rx_data_st;
assign ep5_dout = rx_data_st;
assign ep6_dout = rx_data_st;
assign ep7_dout = rx_data_st;

assign ep0_re = idma_re & (ep_sel == 4'h00);
assign ep1_re = idma_re & (ep_sel == 4'h01) & !ep1_empty;
assign ep2_re = idma_re & (ep_sel == 4'h02) & !ep2_empty;
assign ep3_re = idma_re & (ep_sel == 4'h03) & !ep3_empty;
assign ep4_re = idma_re & (ep_sel == 4'h04) & !ep4_empty;
assign ep5_re = idma_re & (ep_sel == 4'h05) & !ep5_empty;
assign ep6_re = idma_re & (ep_sel == 4'h06) & !ep6_empty;
assign ep7_re = idma_re & (ep_sel == 4'h07) & !ep7_empty;

assign ep0_we = idma_we & (ep_sel == 4'h00);
assign ep1_we = idma_we & (ep_sel == 4'h01) & !ep1_full;
assign ep2_we = idma_we & (ep_sel == 4'h02) & !ep2_full;
assign ep3_we = idma_we & (ep_sel == 4'h03) & !ep3_full;
assign ep4_we = idma_we & (ep_sel == 4'h04) & !ep4_full;
assign ep5_we = idma_we & (ep_sel == 4'h05) & !ep5_full;
assign ep6_we = idma_we & (ep_sel == 4'h06) & !ep6_full;
assign ep7_we = idma_we & (ep_sel == 4'h07) & !ep7_full;

endmodule



`line 1 "C:\simulation_bench_mark\usb11\usb1_funct\rtl\verilog\usb1_crc16.v"





























































`line 1 "C:\simulation_bench_mark\usb11\usb1_funct\rtl\verilog\usb1_defines.v"





































































`line 1 "C:\simulation_bench_mark\usb11\generic_fifos\generic_fifos\rtl\verilog\timescale.v"
`timescale 1ns / 100ps

`line 70 "C:\simulation_bench_mark\usb11\usb1_defines.v"

















































































`line 62 "C:\simulation_bench_mark\usb11\usb1_funct\rtl\verilog\usb1_crc16.v"








module usb1_crc16(crc_in, din, crc_out);
input	[15:0]	crc_in;
input	[7:0]	din;
output	[15:0]	crc_out;

assign crc_out[0] =	din[7] ^ din[6] ^ din[5] ^ din[4] ^ din[3] ^
			din[2] ^ din[1] ^ din[0] ^ crc_in[8] ^ crc_in[9] ^
			crc_in[10] ^ crc_in[11] ^ crc_in[12] ^ crc_in[13] ^
			crc_in[14] ^ crc_in[15];
assign crc_out[1] =	din[7] ^ din[6] ^ din[5] ^ din[4] ^ din[3] ^ din[2] ^
			din[1] ^ crc_in[9] ^ crc_in[10] ^ crc_in[11] ^
			crc_in[12] ^ crc_in[13] ^ crc_in[14] ^ crc_in[15];
assign crc_out[2] =	din[1] ^ din[0] ^ crc_in[8] ^ crc_in[9];
assign crc_out[3] =	din[2] ^ din[1] ^ crc_in[9] ^ crc_in[10];
assign crc_out[4] =	din[3] ^ din[2] ^ crc_in[10] ^ crc_in[11];
assign crc_out[5] =	din[4] ^ din[3] ^ crc_in[11] ^ crc_in[12];
assign crc_out[6] =	din[5] ^ din[4] ^ crc_in[12] ^ crc_in[13];
assign crc_out[7] =	din[6] ^ din[5] ^ crc_in[13] ^ crc_in[14];
assign crc_out[8] =	din[7] ^ din[6] ^ crc_in[0] ^ crc_in[14] ^ crc_in[15];
assign crc_out[9] =	din[7] ^ crc_in[1] ^ crc_in[15];
assign crc_out[10] =	crc_in[2];
assign crc_out[11] =	crc_in[3];
assign crc_out[12] =	crc_in[4];
assign crc_out[13] =	crc_in[5];
assign crc_out[14] =	crc_in[6];
assign crc_out[15] =	din[7] ^ din[6] ^ din[5] ^ din[4] ^ din[3] ^ din[2] ^
			din[1] ^ din[0] ^ crc_in[7] ^ crc_in[8] ^ crc_in[9] ^
			crc_in[10] ^ crc_in[11] ^ crc_in[12] ^ crc_in[13] ^
			crc_in[14] ^ crc_in[15];

endmodule



`line 1 "C:\simulation_bench_mark\usb11\usb1_funct\rtl\verilog\usb1_crc5.v"





























































`line 1 "C:\simulation_bench_mark\usb11\usb1_funct\rtl\verilog\usb1_defines.v"





































































`line 1 "C:\simulation_bench_mark\usb11\generic_fifos\generic_fifos\rtl\verilog\timescale.v"
`timescale 1ns / 100ps

`line 70 "C:\simulation_bench_mark\usb11\usb1_defines.v"

















































































`line 62 "C:\simulation_bench_mark\usb11\usb1_funct\rtl\verilog\usb1_crc5.v"








module usb1_crc5(crc_in, din, crc_out);
input	[4:0]	crc_in;
input	[10:0]	din;
output	[4:0]	crc_out;

assign crc_out[0] =	din[10] ^ din[9] ^ din[6] ^ din[5] ^ din[3] ^
			din[0] ^ crc_in[0] ^ crc_in[3] ^ crc_in[4];

assign crc_out[1] =	din[10] ^ din[7] ^ din[6] ^ din[4] ^ din[1] ^
			crc_in[0] ^ crc_in[1] ^ crc_in[4];

assign crc_out[2] =	din[10] ^ din[9] ^ din[8] ^ din[7] ^ din[6] ^
			din[3] ^ din[2] ^ din[0] ^ crc_in[0] ^ crc_in[1] ^
			crc_in[2] ^ crc_in[3] ^ crc_in[4];

assign crc_out[3] =	din[10] ^ din[9] ^ din[8] ^ din[7] ^ din[4] ^ din[3] ^
			din[1] ^ crc_in[1] ^ crc_in[2] ^ crc_in[3] ^ crc_in[4];

assign crc_out[4] =	din[10] ^ din[9] ^ din[8] ^ din[5] ^ din[4] ^ din[2] ^
			crc_in[2] ^ crc_in[3] ^ crc_in[4];

endmodule



`line 1 "C:\simulation_bench_mark\usb11\usb1_funct\rtl\verilog\usb1_ctrl.v"
































































`line 1 "C:\simulation_bench_mark\usb11\usb1_funct\rtl\verilog\usb1_defines.v"





































































`line 1 "C:\simulation_bench_mark\usb11\generic_fifos\generic_fifos\rtl\verilog\timescale.v"
`timescale 1ns / 100ps

`line 70 "C:\simulation_bench_mark\usb11\usb1_defines.v"

















































































`line 65 "C:\simulation_bench_mark\usb11\usb1_funct\rtl\verilog\usb1_ctrl.v"


module usb1_ctrl(	clk, rst,

			rom_adr, rom_data,

			ctrl_setup, ctrl_in, ctrl_out,

			ep0_din, ep0_dout, ep0_re, ep0_we, ep0_stat,
			ep0_size,

			send_stall, frame_no,
			funct_adr, configured, halt,

			v_set_int, v_set_feature, wValue, wIndex, vendor_data
		);

input		clk, rst;

output	[6:0]	rom_adr;
input	[7:0]	rom_data;

input		ctrl_setup;
input		ctrl_in;
input		ctrl_out;

input	[7:0]	ep0_din;
output	[7:0]	ep0_dout;
output		ep0_re, ep0_we;
input	[3:0]	ep0_stat;
output	[7:0]	ep0_size;

output		send_stall;
input	[10:0]	frame_no;
output	[6:0]	funct_adr;
output		configured, halt;

output		v_set_int;
output		v_set_feature;
output	[15:0]	wValue;
output	[15:0]	wIndex;
input	[15:0]	vendor_data;






parameter	IDLE			=	20'b0000_0000_0000_0000_0001,
		GET_HDR			=	20'b0000_0000_0000_0000_0010,
		GET_STATUS_S		=	20'b0000_0000_0000_0000_0100,
		CLEAR_FEATURE_S		=	20'b0000_0000_0000_0000_1000,
		SET_FEATURE_S		=	20'b0000_0000_0000_0001_0000,
		SET_ADDRESS_S		=	20'b0000_0000_0000_0010_0000,
		GET_DESCRIPTOR_S	=	20'b0000_0000_0000_0100_0000,
		SET_DESCRIPTOR_S	=	20'b0000_0000_0000_1000_0000,
		GET_CONFIG_S		=	20'b0000_0000_0001_0000_0000,
		SET_CONFIG_S		=	20'b0000_0000_0010_0000_0000,
		GET_INTERFACE_S		=	20'b0000_0000_0100_0000_0000,
		SET_INTERFACE_S		=	20'b0000_0000_1000_0000_0000,
		SYNCH_FRAME_S		=	20'b0000_0001_0000_0000_0000,
		WAIT_IN_DATA		=	20'b0000_0010_0000_0000_0000,
		STATUS_IN		=	20'b0000_0100_0000_0000_0000,
		STATUS_OUT		=	20'b0000_1000_0000_0000_0000,
		V_SET_INT_S		=	20'b0001_0000_0000_0000_0000,
		V_GET_STATUS_S		=	20'b0010_0000_0000_0000_0000;


wire	[7:0]	bmReqType, bRequest;
wire	[15:0]	wValue, wIndex, wLength;
wire		bm_req_dir;
wire	[1:0]	bm_req_type;
wire	[4:0]	bm_req_recp;

reg		get_status, clear_feature, set_feature, set_address;
reg		get_descriptor, set_descriptor, get_config, set_config;
reg		get_interface, set_interface, synch_frame;
reg		hdr_done_r, config_err;
reg		v_set_int, v_set_feature, v_get_status;

wire		fifo_re1, fifo_full, fifo_empty;
reg		fifo_we_d;
reg	[4:0]	data_sel;
reg		ep0_we;
reg	[7:0]	ep0_dout;
reg	[7:0]	ep0_size;
reg		send_stall;
reg	[19:0]	state, next_state;
reg		get_hdr;
reg	[7:0]	le;
wire		hdr_done;
reg		adv;
reg	[7:0]	hdr0, hdr1, hdr2, hdr3, hdr4, hdr5, hdr6, hdr7;
reg	[6:0]	funct_adr;
reg		set_adr_pending;
reg	[6:0]	funct_adr_tmp;

reg		in_size_0;
reg		in_size_1;
reg		in_size_2;
wire		high_sel;
reg		write_done, write_done_r;






assign ep0_re = fifo_re1;
assign fifo_empty = ep0_stat[1];
assign fifo_full = ep0_stat[2];





reg	addressed;
reg	configured;
reg	halt;
wire	clr_halt;
wire	set_halt=0;	








assign clr_halt = ctrl_setup;

always @(posedge clk)
	if(!rst)	addressed <= #1 1'b0;
	else
	if(set_address)	addressed <= #1 1'b1;

always @(posedge clk)
	if(!rst)	configured <= #1 1'b0;
	else
	if(set_config)	configured <= #1 1'b1;

always @(posedge clk)
	if(!rst)	halt <= #1 1'b0;
	else
	if(clr_halt)	halt <= #1 1'b0;
	else
	if(set_halt)	halt <= #1 1'b1;





reg	[6:0]	rom_adr;
reg		rom_sel, rom_sel_r;
wire		rom_done;
reg	[6:0]	rom_size;
reg		fifo_we_rom_r;
reg		fifo_we_rom_r2;
wire		fifo_we_rom;
reg	[7:0]	rom_start_d;
reg	[6:0]	rom_size_dd;
wire	[6:0]	rom_size_d;

always @(wValue)
	case(wValue[11:8])		
	   4'h1:	rom_start_d =  7'h00;
	   4'h2:	rom_start_d =  7'h12;
	   4'h3:
		case(wValue[3:0])	
		   4'h00:	rom_start_d =  7'h47;
		   4'h01:	rom_start_d =  7'h50;
		   4'h02:	rom_start_d =  7'h60;
		   4'h03:	rom_start_d =  7'h70;
		   default:	rom_start_d =  7'h47;
		endcase
	   default:	rom_start_d = 7'h00;
	endcase

always @(wValue)
	case(wValue[11:8])		
	   4'h1:	rom_size_dd =  7'd018;
	   4'h2:	rom_size_dd =  7'd053;
	   4'h3:
		case(wValue[3:0])	
		   4'h00:	rom_size_dd =  7'd004;
		   4'h01:	rom_size_dd =  7'd010;
		   4'h02:	rom_size_dd =  7'd010;
		   4'h03:	rom_size_dd =  7'd010;
		   default:	rom_size_dd =  7'd004;
		endcase
	   default:	rom_size_dd = 7'h01;
	endcase

assign rom_size_d = (rom_size_dd > wLength[6:0]) ? wLength[6:0] : rom_size_dd;

always @(posedge clk)
	rom_sel_r <= #1 rom_sel;

always @(posedge clk)
	if(!rst)			rom_adr <= #1 7'h0;
	else
	if(rom_sel & !rom_sel_r)	rom_adr <= #1 rom_start_d;
	else
	if(rom_sel & !fifo_full)	rom_adr <= #1 rom_adr + 7'h1;

always @(posedge clk)
	if(!rst)			rom_size <= #1 7'h0;
	else
	if(rom_sel & !rom_sel_r)	rom_size <= #1 rom_size_d;
	else
	if(rom_sel & !fifo_full)	rom_size <= #1 rom_size - 7'h01;

always @(posedge clk)
	fifo_we_rom_r <= #1 rom_sel;

always @(posedge clk)
	fifo_we_rom_r2 <= #1 fifo_we_rom_r;

assign fifo_we_rom = rom_sel & fifo_we_rom_r2;

assign rom_done = (rom_size == 7'h0) & !(rom_sel & !rom_sel_r);






assign fifo_re1 = get_hdr & !fifo_empty;

always @(posedge clk)
	adv <= #1 get_hdr & !fifo_empty & !adv;

always @(posedge clk)
	if(!rst)	le <= #1 8'h0;
	else
	if(!get_hdr)	le <= #1 8'h0;
	else
	if(!(|le))	le <= #1 8'h1;
	else
	if(adv)		le <= #1 {le[6:0], 1'b0};

always @(posedge clk)
	if(le[0])	hdr0 <= #1 ep0_din;

always @(posedge clk)
	if(le[1])	hdr1 <= #1 ep0_din;

always @(posedge clk)
	if(le[2])	hdr2 <= #1 ep0_din;

always @(posedge clk)
	if(le[3])	hdr3 <= #1 ep0_din;

always @(posedge clk)
	if(le[4])	hdr4 <= #1 ep0_din;

always @(posedge clk)
	if(le[5])	hdr5 <= #1 ep0_din;

always @(posedge clk)
	if(le[6])	hdr6 <= #1 ep0_din;

always @(posedge clk)
	if(le[7])	hdr7 <= #1 ep0_din;

assign hdr_done = le[7] & adv;





parameter	ZERO_DATA	=	5'b00001,
		ZERO_ONE_DATA	=	5'b00010,
		CONFIG_DATA	=	5'b00100,
		SYNC_FRAME_DATA	=	5'b01000,
		VEND_DATA	=	5'b10000;

assign high_sel = write_done_r;

always @(posedge clk)
	case(data_sel)		
	   ZERO_DATA:		ep0_dout <= #1 rom_sel ? rom_data : 8'h0;
	   ZERO_ONE_DATA:	ep0_dout <= #1 high_sel ? 8'h1 : 8'h0;
	   CONFIG_DATA:		ep0_dout <= #1 {7'h0, configured};	
	   SYNC_FRAME_DATA:	ep0_dout <= #1 high_sel ? {5'h0, frame_no[10:8]} : frame_no[7:0];
	   VEND_DATA:		ep0_dout <= #1 high_sel ? vendor_data[15:8] : vendor_data[7:0];
	endcase

always @(posedge clk)
	ep0_we <= #1 fifo_we_d | fifo_we_rom;

always @(posedge clk)
	if(in_size_0)	ep0_size <= #1 8'h0;
	else
	if(in_size_1)	ep0_size <= #1 8'h1;
	else
	if(in_size_2)	ep0_size <= #1 8'h2;
	else
	if(rom_sel)	ep0_size <= #1 {1'b0, rom_size_d};


always @(posedge clk)
	write_done_r <= #1 in_size_2 & !fifo_full & fifo_we_d &
				!write_done_r & !write_done;

always @(posedge clk)
	write_done <= #1 in_size_2 & !fifo_full & fifo_we_d &
				write_done_r & !write_done;







parameter	GET_STATUS	=	8'h00,
		CLEAR_FEATURE	=	8'h01,
		SET_FEATURE	=	8'h03,
		SET_ADDRESS	=	8'h05,
		GET_DESCRIPTOR	=	8'h06,
		SET_DESCRIPTOR	=	8'h07,
		GET_CONFIG	=	8'h08,
		SET_CONFIG	=	8'h09,
		GET_INTERFACE	=	8'h0a,
		SET_INTERFACE	=	8'h0b,
		SYNCH_FRAME	=	8'h0c;

parameter	V_SET_INT	=	8'h0f;
		

assign bmReqType = hdr0;
assign bm_req_dir = bmReqType[7];	
assign bm_req_type = bmReqType[6:5];	
assign bm_req_recp = bmReqType[4:0];	
					
assign bRequest =  hdr1;
assign wValue   = {hdr3, hdr2};
assign wIndex   = {hdr5, hdr4};
assign wLength  = {hdr7, hdr6};

always @(posedge clk)
	hdr_done_r <= #1 hdr_done;


always @(posedge clk)
	get_status <= #1	hdr_done & (bRequest == GET_STATUS) &
								(bm_req_type==2'h0);

always @(posedge clk)
	clear_feature <= #1	hdr_done & (bRequest == CLEAR_FEATURE) &
								(bm_req_type==2'h0);

always @(posedge clk)
	set_feature <= #1	hdr_done & (bRequest == SET_FEATURE) &
								(bm_req_type==2'h0);

always @(posedge clk)
	set_address <= #1	hdr_done & (bRequest == SET_ADDRESS) &
								(bm_req_type==2'h0);

always @(posedge clk)
	get_descriptor <= #1	hdr_done & (bRequest == GET_DESCRIPTOR) &
								(bm_req_type==2'h0);

always @(posedge clk)
	set_descriptor <= #1	hdr_done & (bRequest == SET_DESCRIPTOR) &
								(bm_req_type==2'h0);

always @(posedge clk)
	get_config <= #1	hdr_done & (bRequest == GET_CONFIG) &
								(bm_req_type==2'h0);

always @(posedge clk)
	set_config <= #1	hdr_done & (bRequest == SET_CONFIG) &
								(bm_req_type==2'h0);

always @(posedge clk)
	get_interface <= #1	hdr_done & (bRequest == GET_INTERFACE) &
								(bm_req_type==2'h0);

always @(posedge clk)
	set_interface <= #1	hdr_done & (bRequest == SET_INTERFACE) &
								(bm_req_type==2'h0);

always @(posedge clk)
	synch_frame <= #1	hdr_done & (bRequest == SYNCH_FRAME) &
								(bm_req_type==2'h0);

always @(posedge clk)
	v_set_int <= #1		hdr_done & (bRequest == V_SET_INT) &
								(bm_req_type==2'h2);

always @(posedge clk)
	v_set_feature <= #1	hdr_done & (bRequest == SET_FEATURE) &
								(bm_req_type==2'h2);

always @(posedge clk)
	v_get_status <= #1	hdr_done & (bRequest == GET_STATUS) &
								(bm_req_type==2'h2);


always @(posedge clk)
	config_err <= #1 hdr_done_r & !(get_status | clear_feature |
			set_feature | set_address | get_descriptor |
			set_descriptor | get_config | set_config |
			get_interface | set_interface | synch_frame |
			v_set_int | v_set_feature | v_get_status);

always @(posedge clk)
	send_stall <= #1 config_err;






always @(posedge clk)
	if(!rst)				set_adr_pending <= #1 1'b0;
	else
	if(ctrl_in | ctrl_out | ctrl_setup)	set_adr_pending <= #1 1'b0;
	else
	if(set_address)				set_adr_pending <= #1 1'b1;

always @(posedge clk)
	if(!rst)			funct_adr_tmp <= #1 7'h0;
	else
	if(set_address)			funct_adr_tmp <= #1 wValue[6:0];

always @(posedge clk)
	if(!rst)			funct_adr <= #1 7'h0;
	else
	if(set_adr_pending & ctrl_in)	funct_adr <= #1 funct_adr_tmp;






always @(posedge clk)
	if(!rst)	state <= #1 IDLE;
	else		state <= next_state;

always @(state or ctrl_setup or ctrl_in or ctrl_out or hdr_done or
	fifo_full or rom_done or write_done_r or wValue or bm_req_recp or
	get_status or clear_feature or set_feature or set_address or
	get_descriptor or set_descriptor or get_config or set_config or
	get_interface or set_interface or synch_frame or v_set_int or
	v_set_feature or v_get_status
	)
   begin
	next_state = state;
	get_hdr  = 1'b0;
	data_sel = ZERO_DATA;
	fifo_we_d = 1'b0;
	in_size_0 = 1'b0;
	in_size_1 = 1'b0;
	in_size_2 = 1'b0;
	rom_sel = 1'b0;

	case(state)	

		
	   IDLE:
		   begin
			if(ctrl_setup)		next_state = GET_HDR;
			if(get_status)		next_state = GET_STATUS_S;
			if(clear_feature)	next_state = CLEAR_FEATURE_S;
			if(set_feature)		next_state = SET_FEATURE_S;
			if(set_address)		next_state = SET_ADDRESS_S;
			if(get_descriptor)	next_state = GET_DESCRIPTOR_S;
			if(set_descriptor)	next_state = SET_DESCRIPTOR_S;
			if(get_config)		next_state = GET_CONFIG_S;
			if(set_config)		next_state = SET_CONFIG_S;
			if(get_interface)	next_state = GET_INTERFACE_S;
			if(set_interface)	next_state = SET_INTERFACE_S;
			if(synch_frame)		next_state = SYNCH_FRAME_S;
			if(v_set_int)		next_state = V_SET_INT_S;
			if(v_set_feature)	next_state = V_SET_INT_S;
			if(v_get_status)	next_state = V_GET_STATUS_S;
		   end

		
	   GET_HDR:
		   begin
			get_hdr = 1'b1;
			if(hdr_done)	next_state = IDLE;
		   end


		
	   GET_STATUS_S:
		   begin
			
			
			
			
			if(bm_req_recp == 5'h00)	data_sel = ZERO_ONE_DATA;
			else				data_sel = ZERO_DATA;

			in_size_2 = 1'b1;
			if(!fifo_full)
			   begin
				fifo_we_d = 1'b1;
				if(write_done_r)	next_state = WAIT_IN_DATA;
			   end

		   end
	   V_GET_STATUS_S:
		   begin
			data_sel = VEND_DATA;
			in_size_2 = 1'b1;
			if(!fifo_full)
			   begin
				fifo_we_d = 1'b1;
				if(write_done_r)	next_state = WAIT_IN_DATA;
			   end
		   end

	   CLEAR_FEATURE_S:
		   begin
			
			next_state = STATUS_IN;
		   end

	   SET_FEATURE_S:
		   begin
			
			next_state = STATUS_IN;
		   end

	   SET_ADDRESS_S:
		   begin
			
			next_state = STATUS_IN;
		   end

	   GET_DESCRIPTOR_S:
		   begin
			if(	wValue[15:8] == 8'h01 |
				wValue[15:8] == 8'h02 | 
				wValue[15:8] == 8'h03	)
				rom_sel = 1'b1;
			else
				next_state = IDLE;

			if(rom_done)
				next_state = IDLE;
		   end

	   SET_DESCRIPTOR_S:
		   begin
			
			
			next_state = IDLE;
		   end

	   GET_CONFIG_S:
		   begin
			
			in_size_1 = 1'b1;
			data_sel = CONFIG_DATA;
			if(!fifo_full)
			   begin
				fifo_we_d = 1'b1;
				next_state = WAIT_IN_DATA;
			   end
		   end

	   SET_CONFIG_S:
		   begin
			
			next_state = STATUS_IN;
		   end

	   GET_INTERFACE_S:
		   begin
			
			in_size_1 = 1'b1;
			if(!fifo_full)
			   begin
				fifo_we_d = 1'b1;
				next_state = WAIT_IN_DATA;
			   end
		   end

	   SET_INTERFACE_S:
		   begin
			
			next_state = STATUS_IN;
		   end

	   SYNCH_FRAME_S:
		   begin
			
			data_sel = SYNC_FRAME_DATA;
			in_size_2 = 1'b1;
			if(!fifo_full)
			   begin
				fifo_we_d = 1'b1;
				if(write_done_r)	next_state = WAIT_IN_DATA;
			   end
		   end

	   V_SET_INT_S:
		   begin
			
			next_state = STATUS_IN;
		   end

	   WAIT_IN_DATA:
		   begin
			if(ctrl_in)	next_state = STATUS_OUT;
		   end

	   STATUS_IN:
		   begin
			in_size_0 = 1'b1;
			if(ctrl_in)	next_state = IDLE;
		   end

	   STATUS_OUT:
		   begin
			if(ctrl_out)	next_state = IDLE;
		   end
	endcase
   end

endmodule



`line 1 "C:\simulation_bench_mark\usb11\usb1_funct\rtl\verilog\usb1_fifo2.v"



























































`line 1 "C:\simulation_bench_mark\usb11\generic_fifos\generic_fifos\rtl\verilog\timescale.v"
`timescale 1ns / 100ps

`line 60 "C:\simulation_bench_mark\usb11\usb1_funct\rtl\verilog\usb1_fifo2.v"


module usb1_fifo2(clk, rst, clr,  din, we, dout, re);

input		clk, rst;
input		clr;
input   [7:0]	din;
input		we;
output  [7:0]	dout;
input		re;







reg     [7:0]	mem[0:1];
reg		wp;
reg		rp;






always @(posedge clk or negedge rst)
        if(!rst)	wp <= #1 1'h0;
        else
        if(clr)		wp <= #1 1'h0;
        else
        if(we)		wp <= #1 ~wp;

always @(posedge clk or negedge rst)
        if(!rst)	rp <= #1 1'h0;
        else
        if(clr)		rp <= #1 1'h0;
        else
        if(re)		rp <= #1 ~rp;


assign  dout = mem[ rp ];


always @(posedge clk)
        if(we)     mem[ wp ] <= #1 din;

endmodule



`line 1 "C:\simulation_bench_mark\usb11\usb1_funct\rtl\verilog\usb1_idma.v"
































































`line 1 "C:\simulation_bench_mark\usb11\usb1_funct\rtl\verilog\usb1_defines.v"





































































`line 1 "C:\simulation_bench_mark\usb11\generic_fifos\generic_fifos\rtl\verilog\timescale.v"
`timescale 1ns / 100ps

`line 70 "C:\simulation_bench_mark\usb11\usb1_defines.v"

















































































`line 65 "C:\simulation_bench_mark\usb11\usb1_funct\rtl\verilog\usb1_idma.v"


module usb1_idma(	clk, rst,

		
		rx_data_valid,
		rx_data_done, 
		send_data,
		rd_next,

		tx_valid,
		tx_data_st_i,
		tx_data_st_o,

		
		tx_dma_en, rx_dma_en, idma_done,
		ep_sel,

		
		size,
		rx_cnt, rx_done,
		tx_busy,

		
		ep_bf_en, ep_bf_size,
		dropped_frame, misaligned_frame,

		
		mwe, mre, ep_empty, ep_empty_int, ep_full
		);



input		clk, rst;
input		rx_data_valid;
input		rx_data_done;
output		send_data;
input		rd_next;

input		tx_valid;
input	[7:0]	tx_data_st_i;
output	[7:0]	tx_data_st_o;


input		tx_dma_en;
input		rx_dma_en;
output		idma_done;	
input	[3:0]	ep_sel;


input	[8:0]	size;		
output	[7:0]	rx_cnt;
output		rx_done;
output		tx_busy;

input		ep_bf_en;
input	[6:0]	ep_bf_size;
output		dropped_frame;
output		misaligned_frame;


output		mwe;
output		mre;
input		ep_empty;
output		ep_empty_int;
input		ep_full;






reg		tx_dma_en_r;
reg	[8:0]	sizd_c;			
wire		adr_incw;
wire		adr_incb;
wire		siz_dec;
wire		mwe;			
wire		mre;			
reg		mwe_r;
reg		sizd_is_zero;		
					
wire		sizd_is_zero_d;
reg		idma_done;		
wire		send_data;		
reg		rx_data_done_r;
reg		rx_data_valid_r;
wire		ff_re, ff_full, ff_empty;
reg		ff_we, ff_we1;
reg		tx_dma_en_r1;
reg		tx_dma_en_r2;
reg		tx_dma_en_r3;
reg		send_data_r;
wire		ff_clr;
reg	[7:0]	rx_cnt;
reg	[7:0]	rx_cnt_r;
reg		ep_empty_r;
reg		ep_empty_latched;
wire		ep_empty_int;
reg	[6:0]	ec;
wire		ec_clr;
reg		dropped_frame;
reg	[6:0]	rc_cnt;
wire		rc_clr;
reg		ep_full_latched;
wire		ep_full_int;
reg		misaligned_frame;
reg		tx_valid_r;
wire		tx_valid_e;
























assign ep_empty_int = ep_empty;































assign ep_full_int = ep_full;

always @(posedge clk)
	dropped_frame <= #1 1'b0;

always @(posedge clk)
	misaligned_frame <= #1 1'b0;


















always @(posedge clk)
	mwe_r <= #1 rx_data_valid;

assign mwe = mwe_r & !ep_full_int;






always @(posedge clk)
	rx_data_valid_r <= #1 rx_data_valid;

always @(posedge clk)
	rx_data_done_r <= #1 rx_data_done;


always @(posedge clk)
	tx_dma_en_r <= #1 tx_dma_en;

always @(posedge clk)
	tx_dma_en_r1 <= tx_dma_en_r;

always @(posedge clk)
	tx_dma_en_r2 <= tx_dma_en_r1;

always @(posedge clk)
	tx_dma_en_r3 <= tx_dma_en_r2;


always @(posedge clk)
	idma_done <= #1 (rx_data_done_r | sizd_is_zero_d | ep_empty_int);






always @(posedge clk or negedge rst)
	if(!rst)			rx_cnt_r <= #1 8'h00;
	else
	if(rx_data_done_r)		rx_cnt_r <= #1 8'h00;
	else
	if(rx_data_valid)		rx_cnt_r <= #1 rx_cnt_r + 8'h01;

always @(posedge clk or negedge rst)
	if(!rst)		rx_cnt <= #1 8'h00;
	else
	if(rx_data_done_r)	rx_cnt <= #1 rx_cnt_r;

assign rx_done = rx_data_done_r;







always @(posedge clk or negedge rst)
	if(!rst)			sizd_c <= #1 9'h1ff;
	else
	if(tx_dma_en)			sizd_c <= #1 size;
	else
	if(siz_dec)			sizd_c <= #1 sizd_c - 9'h1;

assign siz_dec = (tx_dma_en_r | tx_dma_en_r1 | rd_next) & !sizd_is_zero_d;

assign sizd_is_zero_d = sizd_c == 9'h0;

always @(posedge clk)
	sizd_is_zero <= #1 sizd_is_zero_d;






assign tx_busy = send_data | tx_dma_en_r | tx_dma_en;

always @(posedge clk)
	tx_valid_r <= #1 tx_valid;

assign tx_valid_e = tx_valid_r & !tx_valid;





always @(posedge clk or negedge rst)
	if(!rst)				ep_empty_r <= #1 1'b0;
	else
	if(!tx_valid)				ep_empty_r <= #1 1'b0;
	else
	if(tx_dma_en_r2)			ep_empty_r <= #1 ep_empty_int;

always @(posedge clk or negedge rst)
	if(!rst)				send_data_r <= #1 1'b0;
	else
	if((tx_dma_en_r & !ep_empty_int))		send_data_r <= #1 1'b1;
	else
	if(rd_next & (sizd_is_zero_d | (ep_empty_int & !sizd_is_zero_d)) )
						send_data_r <= #1 1'b0;

assign send_data = (send_data_r & !ep_empty_r & 
		!(sizd_is_zero & size==9'h01)) | tx_dma_en_r1;

assign mre = (tx_dma_en_r1 | tx_dma_en_r | rd_next) &
		!sizd_is_zero_d & !ep_empty_int & (send_data | tx_dma_en_r1 | tx_dma_en_r);

always @(posedge clk)
	ff_we1 <= mre;

always @(posedge clk)
	ff_we <= ff_we1;

assign ff_re = rd_next;

assign ff_clr = !tx_valid;







usb1_fifo2 ff(
	.clk(		clk		),
	.rst(		rst		),
	.clr(		ff_clr		),
	.din(		tx_data_st_i	),
	.we(		ff_we		),
	.dout(		tx_data_st_o	),
	.re(		ff_re		)
	);

endmodule




`line 1 "C:\simulation_bench_mark\usb11\usb1_funct\rtl\verilog\usb1_pa.v"




























































`line 1 "C:\simulation_bench_mark\usb11\usb1_funct\rtl\verilog\usb1_defines.v"





































































`line 1 "C:\simulation_bench_mark\usb11\generic_fifos\generic_fifos\rtl\verilog\timescale.v"
`timescale 1ns / 100ps

`line 70 "C:\simulation_bench_mark\usb11\usb1_defines.v"

















































































`line 61 "C:\simulation_bench_mark\usb11\usb1_funct\rtl\verilog\usb1_pa.v"


module usb1_pa(	clk, rst,

		
		tx_data, tx_valid, tx_valid_last, tx_ready,
		tx_first,

		
		send_token, token_pid_sel,
		send_data, data_pid_sel,

		
		tx_data_st, rd_next,

		ep_empty
		);

input		clk, rst;


output	[7:0]	tx_data;
output		tx_valid;
output		tx_valid_last;
input		tx_ready;
output		tx_first;


input		send_token;
input	[1:0]	token_pid_sel;
input		send_data;
input	[1:0]	data_pid_sel;


input	[7:0]	tx_data_st;
output		rd_next;

input		ep_empty;






parameter	[3:0]	
		IDLE   = 4'b0001,
		DATA   = 4'b0010,
		CRC1   = 4'b0100,
		CRC2   = 4'b1000;

reg	[3:0]	 state, next_state;


reg		last;
reg		rd_next;

reg	[7:0]	token_pid, data_pid;	
reg	[7:0]	tx_data_d;
reg	[7:0]	tx_data_data;
reg		dsel;
reg		tx_valid_d;
reg		send_token_r;
reg	[7:0]	tx_spec_data;
reg		crc_sel1, crc_sel2;
reg		tx_first_r;
reg		send_data_r;
wire		crc16_clr;
reg	[15:0]	crc16;
wire	[15:0]	crc16_next;
wire	[15:0]	crc16_rev;
reg		crc16_add;
reg		send_data_r2;
reg		tx_valid_r;
reg		tx_valid_r1;

wire		zero_length;





reg		zero_length_r;
assign		zero_length = ep_empty;

always @(posedge clk or negedge rst)
	if(!rst)	zero_length_r <= #1 1'b0;
	else
	if(last)	zero_length_r <= #1 1'b0;
	else
	if(crc16_clr)	zero_length_r <= #1 zero_length;

always @(posedge clk)
	tx_valid_r1 <= #1 tx_valid;

always @(posedge clk)
	tx_valid_r <= #1 tx_valid_r1;

always @(posedge clk or negedge rst)
	if(!rst)	send_token_r <= #1 1'b0;
	else
	if(send_token)	send_token_r <= #1 1'b1;
	else
	if(tx_ready)	send_token_r <= #1 1'b0;


always @(token_pid_sel)
	case(token_pid_sel)		
	   2'd0: token_pid = {  ~ 4'b0010,    4'b0010};
	   2'd1: token_pid = { ~ 4'b1010,   4'b1010};
	   2'd2: token_pid = {~ 4'b1110,  4'b1110};
	   2'd3: token_pid = { ~ 4'b0110,   4'b0110};
	endcase

always @(data_pid_sel)
	case(data_pid_sel)		
	   2'd0: data_pid = { ~ 4'b0011,  4'b0011};
	   2'd1: data_pid = { ~ 4'b1011,  4'b1011};
	   2'd2: data_pid = { ~ 4'b0111,  4'b0111};
	   2'd3: data_pid = { ~ 4'b1111,  4'b1111};
	endcase



always @(send_token or send_token_r or token_pid or tx_data_data)
	if(send_token | send_token_r)	tx_data_d = token_pid;
	else				tx_data_d = tx_data_data;

always @(dsel or tx_data_st or tx_spec_data)
	if(dsel)	tx_data_data = tx_spec_data;
	else		tx_data_data = tx_data_st;

always @(crc_sel1 or crc_sel2 or data_pid or crc16_rev)
	if(!crc_sel1 & !crc_sel2)	tx_spec_data = data_pid;
	else
	if(crc_sel1)			tx_spec_data = crc16_rev[15:8];	
	else				tx_spec_data = crc16_rev[7:0];	

assign tx_data = tx_data_d;


assign tx_valid_last = send_token | last;
assign tx_valid = tx_valid_d;

always @(posedge clk)
	tx_first_r <= #1 send_token | send_data;

assign tx_first = (send_token | send_data) & ! tx_first_r;


always @(posedge clk)
	send_data_r <= #1 send_data;

always @(posedge clk)
	send_data_r2 <= #1 send_data_r;

assign crc16_clr = send_data & !send_data_r;

always @(posedge clk)
	crc16_add <= #1 !zero_length_r &
			((send_data_r & !send_data_r2) | (rd_next & !crc_sel1));

always @(posedge clk)
	if(crc16_clr)		crc16 <= #1 16'hffff;
	else
	if(crc16_add)		crc16 <= #1 crc16_next;

usb1_crc16 u1(
	.crc_in(	crc16		),
	.din(	{tx_data_st[0], tx_data_st[1],
		tx_data_st[2], tx_data_st[3],
		tx_data_st[4], tx_data_st[5],
		tx_data_st[6], tx_data_st[7]}	),
	.crc_out(	crc16_next		) );

assign crc16_rev[15] = ~crc16[8];
assign crc16_rev[14] = ~crc16[9];
assign crc16_rev[13] = ~crc16[10];
assign crc16_rev[12] = ~crc16[11];
assign crc16_rev[11] = ~crc16[12];
assign crc16_rev[10] = ~crc16[13];
assign crc16_rev[9]  = ~crc16[14];
assign crc16_rev[8]  = ~crc16[15];
assign crc16_rev[7]  = ~crc16[0];
assign crc16_rev[6]  = ~crc16[1];
assign crc16_rev[5]  = ~crc16[2];
assign crc16_rev[4]  = ~crc16[3];
assign crc16_rev[3]  = ~crc16[4];
assign crc16_rev[2]  = ~crc16[5];
assign crc16_rev[1]  = ~crc16[6];
assign crc16_rev[0]  = ~crc16[7];






always @(posedge clk or negedge rst)
	if(!rst)	state <= #1 IDLE;
	else		state <= #1 next_state;

always @(state or send_data or tx_ready or tx_valid_r or zero_length)
   begin
	next_state = state;	
	tx_valid_d = 1'b0;
	dsel = 1'b0;
	rd_next = 1'b0;
	last = 1'b0;
	crc_sel1 = 1'b0;
	crc_sel2 = 1'b0;
	case(state)		
	   IDLE:
		   begin
			if(zero_length & send_data)
			   begin
				tx_valid_d = 1'b1;
				dsel = 1'b1;
				next_state = CRC1;
			   end
			else
			if(send_data)		
			   begin
				tx_valid_d = 1'b1;
				dsel = 1'b1;
				next_state = DATA;
			   end
		   end
	   DATA:
		   begin
			if(tx_ready & tx_valid_r)
				rd_next = 1'b1;

			tx_valid_d = 1'b1;
			if(!send_data & tx_ready & tx_valid_r)
			   begin
				dsel = 1'b1;
				crc_sel1 = 1'b1;
				next_state = CRC1;
			   end
		   end
	   CRC1:
		   begin
			dsel = 1'b1;
			tx_valid_d = 1'b1;
			if(tx_ready)
			   begin
				last = 1'b1;
				crc_sel2 = 1'b1;
				next_state = CRC2;
			   end
			else
			   begin
				tx_valid_d = 1'b1;
				crc_sel1 = 1'b1;
			   end

		   end
	   CRC2:
		   begin
			dsel = 1'b1;
			crc_sel2 = 1'b1;
			if(tx_ready)
			   begin
				next_state = IDLE;
			   end
			else
			   begin
				last = 1'b1;
			   end

		   end
	endcase
   end

endmodule



`line 1 "C:\simulation_bench_mark\usb11\usb1_funct\rtl\verilog\usb1_pd.v"


































































`line 1 "C:\simulation_bench_mark\usb11\usb1_funct\rtl\verilog\usb1_defines.v"





































































`line 1 "C:\simulation_bench_mark\usb11\generic_fifos\generic_fifos\rtl\verilog\timescale.v"
`timescale 1ns / 100ps

`line 70 "C:\simulation_bench_mark\usb11\usb1_defines.v"

















































































`line 67 "C:\simulation_bench_mark\usb11\usb1_funct\rtl\verilog\usb1_pd.v"


module usb1_pd(	clk, rst,

		
		rx_data, rx_valid, rx_active, rx_err,

		
		pid_OUT, pid_IN, pid_SOF, pid_SETUP,
		pid_DATA0, pid_DATA1, pid_DATA2, pid_MDATA,
		pid_ACK, pid_NACK, pid_STALL, pid_NYET,
		pid_PRE, pid_ERR, pid_SPLIT, pid_PING,
		pid_cks_err,

		
		token_fadr, token_endp, token_valid, crc5_err,
		frame_no,

		
		rx_data_st, rx_data_valid, rx_data_done, crc16_err,

		
		seq_err, rx_busy
		);

input		clk, rst;

		
input	[7:0]	rx_data;
input		rx_valid, rx_active, rx_err;

		
output		pid_OUT, pid_IN, pid_SOF, pid_SETUP;
output		pid_DATA0, pid_DATA1, pid_DATA2, pid_MDATA;
output		pid_ACK, pid_NACK, pid_STALL, pid_NYET;
output		pid_PRE, pid_ERR, pid_SPLIT, pid_PING;
output		pid_cks_err;		


output	[6:0]	token_fadr;		
output	[3:0]	token_endp;		
output		token_valid;		
output		crc5_err;		
output	[10:0]	frame_no;		

output	[7:0]	rx_data_st;		
output		rx_data_valid;		
output		rx_data_done;		
output		crc16_err;		

output		seq_err;		
output		rx_busy;		






parameter	[3:0]	
		IDLE   = 4'b0001,
		ACTIVE = 4'b0010,
		TOKEN  = 4'b0100,
		DATA   = 4'b1000;

reg	[3:0]	 state, next_state;


reg	[7:0]	pid;			
reg		pid_le_sm;		
wire		pid_ld_en;		
wire		pid_cks_err;		

		
wire		pid_OUT, pid_IN, pid_SOF, pid_SETUP;
wire		pid_DATA0, pid_DATA1, pid_DATA2, pid_MDATA;
wire		pid_ACK, pid_NACK, pid_STALL, pid_NYET;
wire		pid_PRE, pid_ERR, pid_SPLIT, pid_PING, pid_RES;
wire		pid_TOKEN;		
wire		pid_DATA;		

reg	[7:0]	token0, token1;		
reg		token_le_1, token_le_2;	
wire	[4:0]	token_crc5;

reg	[7:0]	d0, d1, d2;		
reg		data_valid_d;		
reg		data_done;		
reg		data_valid0; 		
reg		rxv1;
reg		rxv2;

reg		seq_err;		

reg		pid_ack;

reg		token_valid_r1;
reg		token_valid_str1, token_valid_str2;

reg		rx_active_r;

wire	[4:0]	crc5_out;
wire	[4:0]	crc5_out2;
wire		crc16_clr;
reg	[15:0]	crc16_sum;
wire	[15:0]	crc16_out;






reg	rx_busy, rx_busy_d;

always @(posedge clk or negedge rst)
	if(!rst)			rx_busy_d <= #1 1'b0;
	else
	if(rx_valid & (state == DATA))	rx_busy_d <= #1 1'b1;
	else
	if(state != DATA)		rx_busy_d <= #1 1'b0;

always @(posedge clk)
	rx_busy <= #1 rx_busy_d;


assign pid_ld_en = pid_le_sm & rx_active & rx_valid;

always @(posedge clk or negedge rst)
	if(!rst)		pid <= #1 8'hf0;
	else
	if(pid_ld_en)		pid <= #1 rx_data;

assign	pid_cks_err = (pid[3:0] != ~pid[7:4]);

assign	pid_OUT   = pid[3:0] ==  4'b0001;
assign	pid_IN    = pid[3:0] ==  4'b1001;
assign	pid_SOF   = pid[3:0] ==  4'b0101;
assign	pid_SETUP = pid[3:0] ==  4'b1101;
assign	pid_DATA0 = pid[3:0] ==  4'b0011;
assign	pid_DATA1 = pid[3:0] ==  4'b1011;
assign	pid_DATA2 = pid[3:0] ==  4'b0111;
assign	pid_MDATA = pid[3:0] ==  4'b1111;
assign	pid_ACK   = pid[3:0] ==  4'b0010;
assign	pid_NACK  = pid[3:0] ==  4'b1010;
assign	pid_STALL = pid[3:0] ==  4'b1110;
assign	pid_NYET  = pid[3:0] ==  4'b0110;
assign	pid_PRE   = pid[3:0] ==  4'b1100;
assign	pid_ERR   = pid[3:0] ==  4'b1100;
assign	pid_SPLIT = pid[3:0] ==  4'b1000;
assign	pid_PING  = pid[3:0] ==  4'b0100;
assign	pid_RES   = pid[3:0] ==  4'b0000;

assign	pid_TOKEN = pid_OUT | pid_IN | pid_SOF | pid_SETUP | pid_PING;
assign	pid_DATA = pid_DATA0 | pid_DATA1 | pid_DATA2 | pid_MDATA;


always @(posedge clk)
	if(token_le_1)	token0 <= #1 rx_data;

always @(posedge clk)
	if(token_le_2)	token1 <= #1 rx_data;

always @(posedge clk)
	token_valid_r1 <= #1 token_le_2;

always @(posedge clk)
	token_valid_str1 <= #1 token_valid_r1 | pid_ack;

always @(posedge clk)
	token_valid_str2 <= #1 token_valid_str1;

assign token_valid = token_valid_str1;



assign crc5_err = token_valid & (crc5_out2 != token_crc5);

usb1_crc5 u0(
	.crc_in(	5'h1f			),
	.din(	{	token_fadr[0],
			token_fadr[1],
			token_fadr[2],
			token_fadr[3],
			token_fadr[4],
			token_fadr[5],
			token_fadr[6],
			token_endp[0],
			token_endp[1],
			token_endp[2],
			token_endp[3]   }	),
	.crc_out(	crc5_out		) );


assign	crc5_out2 = ~{crc5_out[0], crc5_out[1], crc5_out[2], crc5_out[3],
			crc5_out[4]};

assign frame_no = { token1[2:0], token0};
assign token_fadr = token0[6:0];
assign token_endp = {token1[2:0], token0[7]};
assign token_crc5 = token1[7:3];



always @(posedge clk or negedge rst)
	if(!rst)		rxv1 <= #1 1'b0;
	else
	if(data_valid_d)	rxv1 <= #1 1'b1;
	else
	if(data_done)		rxv1 <= #1 1'b0;

always @(posedge clk or negedge rst)
	if(!rst)		rxv2 <= #1 1'b0;
	else
	if(rxv1 & data_valid_d)	rxv2 <= #1 1'b1;
	else
	if(data_done)		rxv2 <= #1 1'b0;

always @(posedge clk)
	data_valid0 <= #1 rxv2 & data_valid_d;

always @(posedge clk)
   begin
	if(data_valid_d)	d0 <= #1 rx_data;
	if(data_valid_d)	d1 <= #1 d0;
	if(data_valid_d)	d2 <= #1 d1;
   end

assign rx_data_st = d2;
assign rx_data_valid = data_valid0;
assign rx_data_done = data_done;




always @(posedge clk)
	rx_active_r <= #1 rx_active;

assign crc16_clr = rx_active & !rx_active_r;

always @(posedge clk)
	if(crc16_clr)		crc16_sum <= #1 16'hffff;
	else
	if(data_valid_d)	crc16_sum <= #1 crc16_out;

usb1_crc16 u1(
	.crc_in(	crc16_sum		),
	.din(	{rx_data[0], rx_data[1], rx_data[2], rx_data[3],
		rx_data[4], rx_data[5], rx_data[6], rx_data[7]}	),
	.crc_out(	crc16_out		) );


assign crc16_err = data_done & (crc16_sum != 16'h800d);






always @(posedge clk or negedge rst)
	if(!rst)	state <= #1 IDLE;
	else		state <= #1 next_state;

always @(state or rx_valid or rx_active or rx_err or pid_ACK or pid_TOKEN
	or pid_DATA)
   begin
	next_state = state;	
	pid_le_sm = 1'b0;
	token_le_1 = 1'b0;
	token_le_2 = 1'b0;
	data_valid_d = 1'b0;
	data_done = 1'b0;
	seq_err = 1'b0;
	pid_ack = 1'b0;
	case(state)		
	   IDLE:
		   begin
			pid_le_sm = 1'b1;
			if(rx_valid & rx_active)	next_state = ACTIVE;
		   end
	   ACTIVE:
		   begin
			
			if(pid_ACK & !rx_err)
			   begin
				pid_ack = 1'b1;
				if(!rx_active)	next_state = IDLE;
			   end
			else
			
			if(pid_TOKEN & rx_valid & rx_active & !rx_err)
			   begin
				token_le_1 = 1'b1;
				next_state = TOKEN;
			   end
			else
			
			if(pid_DATA & rx_valid & rx_active & !rx_err)
			   begin
				data_valid_d = 1'b1;
				next_state = DATA;
			   end
			else
			if(	!rx_active | rx_err |
				(rx_valid & !(pid_TOKEN | pid_DATA)) )	
			   begin
				seq_err = !rx_err;
				if(!rx_active)	next_state = IDLE;
			   end
		   end
	   TOKEN:
		   begin
			if(rx_valid & rx_active & !rx_err)
			   begin
				token_le_2 = 1'b1;
				next_state = IDLE;
			   end
			else
			if(!rx_active | rx_err)	
			   begin
				seq_err = !rx_err;
				if(!rx_active)	next_state = IDLE;
			   end
		   end
	   DATA:
		   begin
			if(rx_valid & rx_active & !rx_err)	data_valid_d = 1'b1;
			if(!rx_active | rx_err)
			   begin
				data_done = 1'b1;
				if(!rx_active)	next_state = IDLE;
			   end
		   end
		
	endcase
   end

endmodule



`line 1 "C:\simulation_bench_mark\usb11\usb1_funct\rtl\verilog\usb1_pe.v"




























































`line 1 "C:\simulation_bench_mark\usb11\usb1_funct\rtl\verilog\usb1_defines.v"





































































`line 1 "C:\simulation_bench_mark\usb11\generic_fifos\generic_fifos\rtl\verilog\timescale.v"
`timescale 1ns / 100ps

`line 70 "C:\simulation_bench_mark\usb11\usb1_defines.v"

















































































`line 61 "C:\simulation_bench_mark\usb11\usb1_funct\rtl\verilog\usb1_pe.v"


module usb1_pe(	clk, rst,

		
		tx_valid, rx_active,

		
		pid_OUT, pid_IN, pid_SOF, pid_SETUP,
		pid_DATA0, pid_DATA1, pid_DATA2, pid_MDATA,
		pid_ACK, pid_PING,

		
		token_valid, 

		
		rx_data_done, crc16_err,

		
		send_token, token_pid_sel,
		data_pid_sel,

		
		rx_dma_en, tx_dma_en,
		abort,
		idma_done,

		

		fsel,
		ep_sel, match, nse_err,
		ep_full, ep_empty,

		int_upid_set, int_crc16_set, int_to_set, int_seqerr_set,
		csr,
		send_stall

		);

input		clk, rst;
input		tx_valid, rx_active;


		
input		pid_OUT, pid_IN, pid_SOF, pid_SETUP;
input		pid_DATA0, pid_DATA1, pid_DATA2, pid_MDATA;
input		pid_ACK, pid_PING;

input		token_valid;		

input		rx_data_done;		
input		crc16_err;		


output		send_token;
output	[1:0]	token_pid_sel;
output	[1:0]	data_pid_sel;


output		rx_dma_en;	
output		tx_dma_en;	
output		abort;		
input		idma_done;	

input		ep_full;	
input		ep_empty;	


input		fsel;		
input	[3:0]	ep_sel;		
input		match;		
output		nse_err;	

output		int_upid_set;	
output		int_crc16_set;	
output		int_to_set;	
output		int_seqerr_set;	

input	[13:0]	csr;		

input		send_stall;	








parameter	ACK   = 0,
		NACK  = 1,
		STALL = 2,
		NYET  = 3;


parameter	[9:0]	
		IDLE	= 10'b000000_0001,
		TOKEN	= 10'b000000_0010,
		IN	= 10'b000000_0100,
		IN2	= 10'b000000_1000,
		OUT	= 10'b000001_0000,
		OUT2A	= 10'b000010_0000,
		OUT2B	= 10'b000100_0000,
		UPDATEW	= 10'b001000_0000,
		UPDATE	= 10'b010000_0000,
		UPDATE2	= 10'b100000_0000;

reg	[1:0]	token_pid_sel;
reg	[1:0]	token_pid_sel_d;
reg		send_token;
reg		send_token_d;
reg		rx_dma_en, tx_dma_en;
reg		int_seqerr_set_d;
reg		int_seqerr_set;
reg		int_upid_set;

reg		match_r;


wire		IN_ep, OUT_ep, CTRL_ep;		
wire		txfr_iso, txfr_bulk, txfr_int;	

reg	[1:0]	uc_dpd;


reg	[9:0]	 state, next_state;



reg	[1:0]	next_dpid;
reg	[1:0]	this_dpid;
reg		pid_seq_err;
wire	[1:0]	tr_fr_d;

wire	[13:0]	size_next;
wire		buf_smaller;





reg		rx_ack_to_clr;
reg		rx_ack_to_clr_d;
reg		rx_ack_to;
reg	[7:0]	rx_ack_to_cnt;





wire		tx_data_to_clr;
reg		tx_data_to;
reg	[7:0]	tx_data_to_cnt;

wire	[7:0]	rx_ack_to_val, tx_data_to_val;


wire	[1:0]	next_bsel;
reg		uc_stat_set_d;
reg		uc_dpd_set;

reg		in_token;
reg		out_token;
reg		setup_token;

wire		in_op, out_op;	

reg	[1:0]	allow_pid;

reg		nse_err;
reg		abort;

wire	[1:0]	ep_type, txfr_type;







assign IN_ep   = csr[9];
assign OUT_ep  = csr[10];
assign CTRL_ep = csr[11];

assign txfr_iso  = csr[12];
assign txfr_bulk = csr[13];
assign txfr_int = !csr[12] & !csr[13];

assign ep_type = csr[10:9];
assign txfr_type = csr[13:12];

always @(posedge clk)
	match_r <= #1 match  & fsel;


always @(posedge clk)
	nse_err <= #1 token_valid & (pid_OUT | pid_IN | pid_SETUP) & !match;

always @(posedge clk)
	send_token <= #1 send_token_d;

always @(posedge clk)
	token_pid_sel <= #1 token_pid_sel_d;






reg	[1:0]	ep0_dpid, ep1_dpid, ep2_dpid, ep3_dpid;
reg	[1:0]	ep4_dpid, ep5_dpid, ep6_dpid, ep7_dpid;

always @(posedge clk or negedge rst)
	if(!rst)				ep0_dpid <= 2'b00;
	else
	if(uc_dpd_set & (ep_sel == 4'h0))	ep0_dpid <= next_dpid;

always @(posedge clk or negedge rst)
	if(!rst)				ep1_dpid <= 2'b00;
	else
	if(uc_dpd_set & (ep_sel == 4'h1))	ep1_dpid <= next_dpid;

always @(posedge clk or negedge rst)
	if(!rst)				ep2_dpid <= 2'b00;
	else
	if(uc_dpd_set & (ep_sel == 4'h2))	ep2_dpid <= next_dpid;

always @(posedge clk or negedge rst)
	if(!rst)				ep3_dpid <= 2'b00;
	else
	if(uc_dpd_set & (ep_sel == 4'h3))	ep3_dpid <= next_dpid;

always @(posedge clk or negedge rst)
	if(!rst)				ep4_dpid <= 2'b00;
	else
	if(uc_dpd_set & (ep_sel == 4'h4))	ep4_dpid <= next_dpid;

always @(posedge clk or negedge rst)
	if(!rst)				ep5_dpid <= 2'b00;
	else
	if(uc_dpd_set & (ep_sel == 4'h5))	ep5_dpid <= next_dpid;

always @(posedge clk or negedge rst)
	if(!rst)				ep6_dpid <= 2'b00;
	else
	if(uc_dpd_set & (ep_sel == 4'h6))	ep6_dpid <= next_dpid;

always @(posedge clk or negedge rst)
	if(!rst)				ep7_dpid <= 2'b00;
	else
	if(uc_dpd_set & (ep_sel == 4'h7))	ep7_dpid <= next_dpid;

always @(posedge clk)
	case(ep_sel)
	   4'h0: uc_dpd <= ep0_dpid;
	   4'h1: uc_dpd <= ep1_dpid;
	   4'h2: uc_dpd <= ep2_dpid;
	   4'h3: uc_dpd <= ep3_dpid;
	   4'h4: uc_dpd <= ep4_dpid;
	   4'h5: uc_dpd <= ep5_dpid;
	   4'h6: uc_dpd <= ep6_dpid;
	   4'h7: uc_dpd <= ep7_dpid;
	endcase






assign tr_fr_d = 2'h0;

always @(posedge clk)	
	casex({tr_fr_d,ep_type,txfr_type,uc_dpd})	
	   8'b0?_01_01_??: next_dpid <= #1 2'b00;	

	   8'b10_01_01_?0: next_dpid <= #1 2'b01;	
	   8'b10_01_01_?1: next_dpid <= #1 2'b00;	

	   8'b11_01_01_00: next_dpid <= #1 2'b01;	
	   8'b11_01_01_01: next_dpid <= #1 2'b10;	
	   8'b11_01_01_10: next_dpid <= #1 2'b00;	

	   8'b0?_10_01_??: next_dpid <= #1 2'b00;	

	   8'b10_10_01_??: 				
			   begin	
				case({pid_MDATA, pid_DATA1})	
				  2'b10: next_dpid <= #1 2'b01;
				  2'b01: next_dpid <= #1 2'b00;
				endcase
			   end

	   8'b11_10_01_00: 				
			   begin	
				case({pid_MDATA, pid_DATA2})	
				  2'b10: next_dpid <= #1 2'b01;
				  2'b01: next_dpid <= #1 2'b00;
				endcase
			   end
	   8'b11_10_01_01: 				
			   begin	
				case({pid_MDATA, pid_DATA2})	
				  2'b10: next_dpid <= #1 2'b10;
				  2'b01: next_dpid <= #1 2'b00;
				endcase
			   end
	   8'b11_10_01_10: 				
			   begin	
				case({pid_MDATA, pid_DATA2})	
				  2'b10: next_dpid <= #1 2'b01;
				  2'b01: next_dpid <= #1 2'b00;
				endcase
			   end

	   8'b??_01_00_?0,				
	   8'b??_10_00_?0: next_dpid <= #1 2'b01;	

	   8'b??_01_00_?1,				
	   8'b??_10_00_?1: next_dpid <= #1 2'b00;	

	   8'b??_01_10_?0,				
	   8'b??_10_10_?0: next_dpid <= #1 2'b01;	

	   8'b??_01_10_?1,				
	   8'b??_10_10_?1: next_dpid <= #1 2'b00;	

	   8'b??_00_??_??:				
		casex({setup_token, in_op, out_op, uc_dpd})	
		   5'b1_??_??: next_dpid <= #1 2'b11;	
		   5'b0_10_0?: next_dpid <= #1 2'b11;	
		   5'b0_10_1?: next_dpid <= #1 2'b01;	
		   5'b0_01_?0: next_dpid <= #1 2'b11;	
		   5'b0_01_?1: next_dpid <= #1 2'b10;	
		endcase

	endcase




always @(pid_DATA0 or pid_DATA1 or pid_DATA2 or pid_MDATA)
	case({pid_DATA0, pid_DATA1, pid_DATA2, pid_MDATA} ) 
	   4'b1000: allow_pid = 2'b00;
	   4'b0100: allow_pid = 2'b01;
	   4'b0010: allow_pid = 2'b10;
	   4'b0001: allow_pid = 2'b11;
	endcase

always @(posedge clk)	
	casex({tr_fr_d,ep_type,txfr_type,uc_dpd})	
	   8'b0?_01_01_??: this_dpid <= #1 2'b00;	

	   8'b10_01_01_?0: this_dpid <= #1 2'b01;	
	   8'b10_01_01_?1: this_dpid <= #1 2'b00;	

	   8'b11_01_01_00: this_dpid <= #1 2'b10;	
	   8'b11_01_01_01: this_dpid <= #1 2'b01;	
	   8'b11_01_01_10: this_dpid <= #1 2'b00;	

	   8'b00_10_01_??: this_dpid <= #1 allow_pid;	
	   8'b01_10_01_??: this_dpid <= #1 2'b00;	

	   8'b10_10_01_?0: this_dpid <= #1 2'b11;	
	   8'b10_10_01_?1: this_dpid <= #1 2'b01;	

	   8'b11_10_01_00: this_dpid <= #1 2'b11;	
	   8'b11_10_01_01: this_dpid <= #1 2'b11;	
	   8'b11_10_01_10: this_dpid <= #1 2'b10;	

	   8'b??_01_00_?0,				
	   8'b??_10_00_?0: this_dpid <= #1 2'b00;	
	   8'b??_01_00_?1,				
	   8'b??_10_00_?1: this_dpid <= #1 2'b01;	

	   8'b??_01_10_?0,				
	   8'b??_10_10_?0: this_dpid <= #1 2'b00;	
	   8'b??_01_10_?1,				
	   8'b??_10_10_?1: this_dpid <= #1 2'b01;	

	   8'b??_00_??_??:				
		casex({setup_token,in_op, out_op, uc_dpd})	
		   5'b1_??_??: this_dpid <= #1 2'b00;	
		   5'b0_10_0?: this_dpid <= #1 2'b00;	
		   5'b0_10_1?: this_dpid <= #1 2'b01;	
		   5'b0_01_?0: this_dpid <= #1 2'b00;	
		   5'b0_01_?1: this_dpid <= #1 2'b01;	
		endcase
	endcase


assign data_pid_sel = this_dpid;


always @(posedge clk)
	pid_seq_err <= #1 !(	(this_dpid==2'b00 & pid_DATA0) |
				(this_dpid==2'b01 & pid_DATA1) |
				(this_dpid==2'b10 & pid_DATA2) |
				(this_dpid==2'b11 & pid_MDATA)	);











always @(posedge clk or negedge rst)
	if(!rst)		in_token <= #1 1'b0;
	else
	if(pid_IN)		in_token <= #1 1'b1;
	else
	if(pid_OUT | pid_SETUP)	in_token <= #1 1'b0;

always @(posedge clk or negedge rst)
	if(!rst)		out_token <= #1 1'b0;
	else
	if(pid_OUT | pid_SETUP)	out_token <= #1 1'b1;
	else
	if(pid_IN)		out_token <= #1 1'b0;

always @(posedge clk or negedge rst)
	if(!rst)		setup_token <= #1 1'b0;
	else
	if(pid_SETUP)		setup_token <= #1 1'b1;
	else
	if(pid_OUT | pid_IN)	setup_token <= #1 1'b0;


assign	in_op = IN_ep | (CTRL_ep & in_token);


assign	out_op = OUT_ep | (CTRL_ep & out_token);














always @(posedge clk)
	uc_dpd_set <= #1 uc_stat_set_d;


always @(posedge clk)
	abort <= #1 match & fsel & (state != IDLE);












always @(posedge clk)
	rx_ack_to_clr <= #1 tx_valid | rx_ack_to_clr_d;

always @(posedge clk)
	if(rx_ack_to_clr)	rx_ack_to_cnt <= #1 8'h0;
	else			rx_ack_to_cnt <= #1 rx_ack_to_cnt + 8'h1;

always @(posedge clk)
	rx_ack_to <= #1 (rx_ack_to_cnt == rx_ack_to_val);

assign rx_ack_to_val =  8'd200;







assign	tx_data_to_clr = rx_active;

always @(posedge clk)
	if(tx_data_to_clr)	tx_data_to_cnt <= #1 8'h0;
	else			tx_data_to_cnt <= #1 tx_data_to_cnt + 8'h1;

always @(posedge clk)
	tx_data_to <= #1 (tx_data_to_cnt == tx_data_to_val);

assign tx_data_to_val =  8'd200;





reg	pid_OUT_r, pid_IN_r, pid_PING_r, pid_SETUP_r;

always @(posedge clk)
	pid_OUT_r <= #1 pid_OUT;

always @(posedge clk)
	pid_IN_r <= #1 pid_IN;

always @(posedge clk)
	pid_PING_r <= #1 pid_PING;

always @(posedge clk)
	pid_SETUP_r <= #1 pid_SETUP;

always @(posedge clk)
	int_upid_set <= #1 match_r & !pid_SOF & (
				( OUT_ep & !(pid_OUT_r | pid_PING_r))		|
				(  IN_ep &  !pid_IN_r)				|
				(CTRL_ep & !(pid_IN_r | pid_OUT_r | pid_PING_r | pid_SETUP_r))
					);


assign int_to_set  = ((state == IN2) & rx_ack_to) | ((state == OUT) & tx_data_to);

assign int_crc16_set = rx_data_done & crc16_err;

always @(posedge clk)
	int_seqerr_set <= #1 int_seqerr_set_d;

reg	send_stall_r;

always @(posedge clk or negedge rst)
	if(!rst)	send_stall_r <= #1 1'b0;
	else
	if(send_stall)	send_stall_r <= #1 1'b1;
	else	
	if(send_token)	send_stall_r <= #1 1'b0;






always @(posedge clk or negedge rst)
	if(!rst)	state <= #1 IDLE;
	else
	if(match)	state <= #1 IDLE;
	else		state <= #1 next_state;

always @(state or 
	pid_seq_err or idma_done or ep_full or ep_empty or
	token_valid or pid_ACK or rx_data_done or
	tx_data_to or crc16_err or 
	rx_ack_to or pid_PING or txfr_iso or txfr_int or
	CTRL_ep or pid_IN or pid_OUT or IN_ep or OUT_ep or pid_SETUP or pid_SOF
	or match_r or abort or send_stall_r
	)
   begin
	next_state = state;
	token_pid_sel_d = ACK;
	send_token_d = 1'b0;
	rx_dma_en = 1'b0;
	tx_dma_en = 1'b0;
	uc_stat_set_d = 1'b0;
	rx_ack_to_clr_d = 1'b1;
	int_seqerr_set_d = 1'b0;

	case(state)	
	   IDLE:
		   begin




















			if(match_r & !pid_SOF)
			   begin









				if(IN_ep | (CTRL_ep & pid_IN))
				   begin
					if(txfr_int & ep_empty)
					   begin
						token_pid_sel_d = NACK;
						send_token_d = 1'b1;
						next_state = TOKEN;
					   end
					else
					   begin
						tx_dma_en = 1'b1;
						next_state = IN;
					   end
				   end
				else
				if(OUT_ep | (CTRL_ep & (pid_OUT | pid_SETUP)))
				   begin
					rx_dma_en = 1'b1;
					next_state = OUT;
				   end
			   end
		   end

	   TOKEN:
		   begin





			next_state = IDLE;
		   end

	   IN:
		   begin









			rx_ack_to_clr_d = 1'b0;
			if(idma_done)
			   begin
				if(txfr_iso)	next_state = UPDATE;
				else		next_state = IN2;
			   end

		   end
	   IN2:
		   begin










			rx_ack_to_clr_d = 1'b0;
			
			if(rx_ack_to)	next_state = IDLE;
			else
			if(token_valid & pid_ACK)
			   begin
				next_state = UPDATE;
			   end
		   end

	   OUT:
		   begin













			if(tx_data_to | crc16_err | abort )
				next_state = IDLE;
			else
			if(rx_data_done)
			   begin		
				if(txfr_iso)
				   begin
					if(pid_seq_err)		int_seqerr_set_d = 1'b1;
					next_state = UPDATEW;
				   end
				else		next_state = OUT2A;
			   end
		   end

	   OUT2B:
		   begin	
				








			if(abort)	next_state = IDLE;
			else		next_state = OUT2B;
		   end
	   OUT2A:
		   begin	









			if(abort)	next_state = IDLE;
			else

			if(send_stall_r)
			   begin
				token_pid_sel_d = STALL;
				send_token_d = 1'b1;
				next_state = IDLE;
			   end
			else
			if(ep_full)
			   begin
				token_pid_sel_d = NACK;
				send_token_d = 1'b1;
				next_state = IDLE;
			   end
			else
			   begin
				token_pid_sel_d = ACK;
				send_token_d = 1'b1;
				if(pid_seq_err)	next_state = IDLE;
				else		next_state = UPDATE;
			   end
		   end

	   UPDATEW:
		   begin





			next_state = UPDATE;
		   end

	   UPDATE:
		   begin





			uc_stat_set_d = 1'b1;
			next_state = IDLE;
		   end
	endcase
   end

endmodule



`line 1 "C:\simulation_bench_mark\usb11\usb1_funct\rtl\verilog\usb1_pl.v"




































































`line 1 "C:\simulation_bench_mark\usb11\usb1_funct\rtl\verilog\usb1_defines.v"





































































`line 1 "C:\simulation_bench_mark\usb11\generic_fifos\generic_fifos\rtl\verilog\timescale.v"
`timescale 1ns / 100ps

`line 70 "C:\simulation_bench_mark\usb11\usb1_defines.v"

















































































`line 69 "C:\simulation_bench_mark\usb11\usb1_funct\rtl\verilog\usb1_pl.v"

module usb1_pl(	clk, rst,

		
		rx_data, rx_valid, rx_active, rx_err,
		tx_data, tx_valid, tx_valid_last, tx_ready,
		tx_first, tx_valid_out,

		token_valid,

		
		fa,
		ep_sel, 
		x_busy,
		int_crc16_set, int_to_set, int_seqerr_set,

		
		frm_nat,
		pid_cs_err, nse_err,
		crc5_err,
		rx_size, rx_done,
		ctrl_setup, ctrl_in, ctrl_out,

		
		ep_bf_en, ep_bf_size,
		dropped_frame, misaligned_frame,

		
		csr,
		tx_data_st, rx_data_st, idma_re, idma_we,
		ep_empty, ep_full, send_stall

		);


input		clk, rst;
input	[7:0]	rx_data;
input		rx_valid, rx_active, rx_err;
output	[7:0]	tx_data;
output		tx_valid;
output		tx_valid_last;
input		tx_ready;
output		tx_first;
input		tx_valid_out;

output		token_valid;


input	[6:0]	fa;		
output	[3:0]	ep_sel;		
output		x_busy;		

output		int_crc16_set;	
output		int_to_set;	
output		int_seqerr_set;	


output		pid_cs_err;	
output		crc5_err;	
output	[31:0]	frm_nat;
output		nse_err;	
output	[7:0]	rx_size;
output		rx_done;
output		ctrl_setup;
output		ctrl_in;
output		ctrl_out;
input		ep_bf_en;
input	[6:0]	ep_bf_size;
output		dropped_frame, misaligned_frame;


input	[13:0]	csr;	
input	[7:0]	tx_data_st;
output	[7:0]	rx_data_st;
output		idma_re, idma_we;
input		ep_empty;
input		ep_full;

input		send_stall;







wire		clk, rst;
wire	[7:0]	rx_data;
wire		pid_OUT, pid_IN, pid_SOF, pid_SETUP;
wire		pid_DATA0, pid_DATA1, pid_DATA2, pid_MDATA;
wire		pid_ACK, pid_NACK, pid_STALL, pid_NYET;
wire		pid_PRE, pid_ERR, pid_SPLIT, pid_PING;
wire	[6:0]	token_fadr;
wire		token_valid;
wire		crc5_err;
wire	[10:0]	frame_no;
reg	[7:0]	rx_data_st;
wire	[7:0]	rx_data_st_d;
wire		rx_data_valid;
wire		rx_data_done;
wire		crc16_err;
wire		rx_seq_err;


wire		send_token;
wire	[1:0]	token_pid_sel;
wire		send_data;
wire	[1:0]	data_pid_sel;
wire	[7:0]	tx_data_st;
wire	[7:0]	tx_data_st_o;
wire		rd_next;


wire		rx_dma_en;	
wire		tx_dma_en;	
wire		abort;		
wire		idma_done;	


wire		idma_we;
wire		idma_re;


wire		pid_bad;

reg		hms_clk;	
reg	[4:0]	hms_cnt;
reg	[10:0]	frame_no_r;	
wire		frame_no_we;
reg	[11:0]	sof_time;	
reg		clr_sof_time;
wire		fsel;		
wire		match_o;

reg		frame_no_we_r;
reg		ctrl_setup;
reg		ctrl_in;
reg		ctrl_out;

wire		idma_we_d;
wire		ep_empty_int;
wire		rx_busy;
wire		tx_busy;






assign x_busy = tx_busy | rx_busy;


assign pid_bad = pid_ACK | pid_NACK | pid_STALL | pid_NYET | pid_PRE |
			pid_ERR | pid_SPLIT |  pid_PING;

assign match_o = !pid_bad & token_valid & !crc5_err;


always @(posedge clk)
	ctrl_setup <= #1 token_valid & pid_SETUP & (ep_sel==4'h0);

always @(posedge clk)
	ctrl_in <= #1 token_valid & pid_IN & (ep_sel==4'h0);

always @(posedge clk)
	ctrl_out <= #1 token_valid & pid_OUT & (ep_sel==4'h0);


assign frame_no_we = token_valid & !crc5_err & pid_SOF;

always @(posedge clk)
	frame_no_we_r <= #1 frame_no_we;

always @(posedge clk or negedge rst)
	if(!rst)		frame_no_r <= #1 11'h0;
	else
	if(frame_no_we_r)	frame_no_r <= #1 frame_no;


always @(posedge clk)
	clr_sof_time <= #1 frame_no_we;

always @(posedge clk)
	if(clr_sof_time)	sof_time <= #1 12'h0;
	else
	if(hms_clk)		sof_time <= #1 sof_time + 12'h1;

assign frm_nat = {4'h0, 1'b0, frame_no_r, 4'h0, sof_time};


always @(posedge clk or negedge rst)
	if(!rst)				hms_cnt <= #1 5'h0;
	else
	if(hms_clk | frame_no_we_r)		hms_cnt <= #1 5'h0;
	else					hms_cnt <= #1 hms_cnt + 5'h1;

always @(posedge clk)
	hms_clk <= #1 (hms_cnt ==  5'h16);

always @(posedge clk)
	rx_data_st <= rx_data_st_d;




assign fsel = (token_fadr == fa);


assign idma_we = idma_we_d & fsel; 







usb1_pd	u0(	.clk(		clk		),
		.rst(		rst		),

		.rx_data(	rx_data		),
		.rx_valid(	rx_valid	),
		.rx_active(	rx_active	),
		.rx_err(	rx_err		),
		.pid_OUT(	pid_OUT		),
		.pid_IN(	pid_IN		),
		.pid_SOF(	pid_SOF		),
		.pid_SETUP(	pid_SETUP	),
		.pid_DATA0(	pid_DATA0	),
		.pid_DATA1(	pid_DATA1	),
		.pid_DATA2(	pid_DATA2	),
		.pid_MDATA(	pid_MDATA	),
		.pid_ACK(	pid_ACK		),
		.pid_NACK(	pid_NACK	),
		.pid_STALL(	pid_STALL	),
		.pid_NYET(	pid_NYET	),
		.pid_PRE(	pid_PRE		),
		.pid_ERR(	pid_ERR		),
		.pid_SPLIT(	pid_SPLIT	),
		.pid_PING(	pid_PING	),
		.pid_cks_err(	pid_cs_err	),
		.token_fadr(	token_fadr	),
		.token_endp(	ep_sel		),
		.token_valid(	token_valid	),
		.crc5_err(	crc5_err	),
		.frame_no(	frame_no	),
		.rx_data_st(	rx_data_st_d	),
		.rx_data_valid(	rx_data_valid	),
		.rx_data_done(	rx_data_done	),
		.crc16_err(	crc16_err	),
		.seq_err(	rx_seq_err	),
		.rx_busy(	rx_busy		)
		);


usb1_pa	u1(	.clk(		clk		),
		.rst(		rst		),
		.tx_data(	tx_data		),
		.tx_valid(	tx_valid	),
		.tx_valid_last(	tx_valid_last	),
		.tx_ready(	tx_ready	),
		.tx_first(	tx_first	),
		.send_token(	send_token	),
		.token_pid_sel(	token_pid_sel	),
		.send_data(	send_data	),
		.data_pid_sel(	data_pid_sel	),
		.tx_data_st(	tx_data_st_o	),
		.rd_next(	rd_next		),
		.ep_empty(	ep_empty_int)
		);


usb1_idma
	u2(	.clk(		clk		),
		.rst(		rst		),

		.tx_valid(	tx_valid	),
		.rx_data_valid(	rx_data_valid	),
		.rx_data_done(	rx_data_done	),
		.send_data(	send_data	),
		.rd_next(	rd_next		),

		.tx_data_st_i(	tx_data_st	),
		.tx_data_st_o(	tx_data_st_o	),
		.ep_sel(	ep_sel		),

		.ep_bf_en(	ep_bf_en	),
		.ep_bf_size(	ep_bf_size	),
		.dropped_frame(dropped_frame	),
		.misaligned_frame(misaligned_frame),

		.tx_busy(	tx_busy		),

		.tx_dma_en(	tx_dma_en	),
		.rx_dma_en(	rx_dma_en	),
		.idma_done(	idma_done	),
		.size(		csr[8:0]	),
		.rx_cnt(	rx_size		),
		.rx_done(	rx_done		),
		.mwe(		idma_we_d	),
		.mre(		idma_re		),
		.ep_empty(	ep_empty	),
		.ep_empty_int(	ep_empty_int	),
		.ep_full(	ep_full		)
		);


usb1_pe
	u3(	.clk(			clk			),
		.rst(			rst			),

		.tx_valid(		tx_valid_out		),
		.rx_active(		rx_active		),
		.pid_OUT(		pid_OUT			),
		.pid_IN(		pid_IN			),
		.pid_SOF(		pid_SOF			),
		.pid_SETUP(		pid_SETUP		),
		.pid_DATA0(		pid_DATA0		),
		.pid_DATA1(		pid_DATA1		),
		.pid_DATA2(		pid_DATA2		),
		.pid_MDATA(		pid_MDATA		),
		.pid_ACK(		pid_ACK			),
		.pid_PING(		pid_PING		),
		.token_valid(		token_valid		),
		.rx_data_done(		rx_data_done		),
		.crc16_err(		crc16_err		),
		.send_token(		send_token		),
		.token_pid_sel(		token_pid_sel		),
		.data_pid_sel(		data_pid_sel		),
		.rx_dma_en(		rx_dma_en		),
		.tx_dma_en(		tx_dma_en		),
		.abort(			abort			),
		.idma_done(		idma_done		),
		.fsel(			fsel			),
		.ep_sel(		ep_sel			),
		.ep_full(		ep_full			),
		.ep_empty(		ep_empty		),
		.match(			match_o			),
		.nse_err(		nse_err			),
		.int_upid_set(		int_upid_set		),
		.int_crc16_set(		int_crc16_set		),
		.int_to_set(		int_to_set		),
		.int_seqerr_set(	int_seqerr_set		),
		.csr(			csr			),
		.send_stall(		send_stall		)
		);

endmodule


`line 1 "C:\simulation_bench_mark\usb11\usb1_funct\rtl\verilog\usb1_rom1.v"



























































`line 1 "C:\simulation_bench_mark\usb11\usb1_funct\rtl\verilog\usb1_defines.v"





































































`line 1 "C:\simulation_bench_mark\usb11\generic_fifos\generic_fifos\rtl\verilog\timescale.v"
`timescale 1ns / 100ps

`line 70 "C:\simulation_bench_mark\usb11\usb1_defines.v"

















































































`line 60 "C:\simulation_bench_mark\usb11\usb1_funct\rtl\verilog\usb1_rom1.v"


module usb1_rom1(clk, adr, dout);
input		clk;
input	[6:0]	adr;
output	[7:0]	dout;

reg	[7:0]	dout;

always @(posedge clk)
	case(adr)	

		
		
		

	   7'h00:	dout <= #1 8'd18;	
	   7'h01:	dout <= #1 8'h01;	
	   7'h02:	dout <= #1 8'h00;	
	   7'h03:	dout <= #1 8'h01;	
	   7'h04:	dout <= #1 8'hff;	
	   7'h05:	dout <= #1 8'h00;	
	   7'h06:	dout <= #1 8'hff;	
	   7'h07:	dout <= #1 8'd64;	
	   7'h08:	dout <= #1 8'h34;	
	   7'h09:	dout <= #1 8'h12;	
	   7'h0a:	dout <= #1 8'h78;	
	   7'h0b:	dout <= #1 8'h56;	
	   7'h0c:	dout <= #1 8'h10;	
	   7'h0d:	dout <= #1 8'h00;	
	   7'h0e:	dout <= #1 8'h00;	
	   7'h0f:	dout <= #1 8'h00;	
	   7'h10:	dout <= #1 8'h00;	
	   7'h11:	dout <= #1 8'h01;	

		
		
		
	   7'h12:	dout <= #1 8'h09;	
	   7'h13:	dout <= #1 8'h02;	
	   7'h14:	dout <= #1 8'd53;	
	   7'h15:	dout <= #1 8'd00;	
	   7'h16:	dout <= #1 8'h01;	
	   7'h17:	dout <= #1 8'h01;	
	   7'h18:	dout <= #1 8'h00;	
	   7'h19:	dout <= #1 8'h40;	
	   7'h1a:	dout <= #1 8'h00;	

		
		
		
	   7'h1b:	dout <= #1 8'h09;	
	   7'h1c:	dout <= #1 8'h04;	
	   7'h1d:	dout <= #1 8'h00;	
	   7'h1e:	dout <= #1 8'h00;	
	   7'h1f:	dout <= #1 8'h05;	
	   7'h20:	dout <= #1 8'hff;	
	   7'h21:	dout <= #1 8'h01;	
	   7'h22:	dout <= #1 8'hff;	
	   7'h23:	dout <= #1 8'h00;	

		
		
		
	   7'h24:	dout <= #1 8'h07;	
	   7'h25:	dout <= #1 8'h05;	
	   7'h26:	dout <= #1 8'h81;	
	   7'h27:	dout <= #1 8'h01;	
	   7'h28:	dout <= #1 8'h00;	
	   7'h29:	dout <= #1 8'h01;	
	   7'h2a:	dout <= #1 8'h01;	

		
		
		
	   7'h2b:	dout <= #1 8'h07;	
	   7'h2c:	dout <= #1 8'h05;	
	   7'h2d:	dout <= #1 8'h02;	
	   7'h2e:	dout <= #1 8'h01;	
	   7'h2f:	dout <= #1 8'h00;	
	   7'h30:	dout <= #1 8'h01;	
	   7'h31:	dout <= #1 8'h01;	

		
		
		
	   7'h32:	dout <= #1 8'h07;	
	   7'h33:	dout <= #1 8'h05;	
	   7'h34:	dout <= #1 8'h83;	
	   7'h35:	dout <= #1 8'h02;	
	   7'h36:	dout <= #1 8'd64;	
	   7'h37:	dout <= #1 8'd00;	
	   7'h38:	dout <= #1 8'h01;	

		
		
		
	   7'h39:	dout <= #1 8'h07;	
	   7'h3a:	dout <= #1 8'h05;	
	   7'h3b:	dout <= #1 8'h04;	
	   7'h3c:	dout <= #1 8'h02;	
	   7'h3d:	dout <= #1 8'd64;	
	   7'h3e:	dout <= #1 8'd00;	
	   7'h3f:	dout <= #1 8'h01;	

		
		
		
	   7'h40:	dout <= #1 8'h07;	
	   7'h41:	dout <= #1 8'h05;	
	   7'h42:	dout <= #1 8'h85;	
	   7'h43:	dout <= #1 8'h03;	
	   7'h44:	dout <= #1 8'd64;	
	   7'h45:	dout <= #1 8'd00;	
	   7'h46:	dout <= #1 8'h01;	

































































		
		

	   
	endcase

endmodule


`line 1 "C:\simulation_bench_mark\usb11\usb1_funct\rtl\verilog\timescale.v"
`timescale 1ns / 10ps


`line 1 "C:\simulation_bench_mark\usb11\usb1_funct\bench\verilog\timescale.v"
`timescale 1ns / 10ps 


`line 1 "C:\simulation_bench_mark\usb11\usb1_funct\bench\verilog\test_bench_top.v"






































`line 1 "C:\simulation_bench_mark\usb11\usb1_funct\rtl\verilog\usb1_defines.v"





































































`line 1 "C:\simulation_bench_mark\usb11\generic_fifos\generic_fifos\rtl\verilog\timescale.v"
`timescale 1ns / 100ps

`line 70 "C:\simulation_bench_mark\usb11\usb1_defines.v"

















































































`line 39 "C:\simulation_bench_mark\usb11\usb1_funct\bench\verilog\test_bench_top.v"


module test;






reg		clk;
reg		clk2;
reg		rst;

integer		error_cnt;
reg	[7:0]	txmem[0:2048];
reg	[7:0]	buffer1[0:16384];
reg	[7:0]	buffer0[0:16384];
integer		buffer1_last;
reg	[31:0]	wd_cnt;
reg		setup_pid;
integer		pack_sz, pack_sz_max;
wire		tx_dp, tx_dn, tx_oe;
wire		rx_d, rx_dp, rx_dn;
reg		tb_tx_valid;
wire		tb_tx_ready;
reg	[7:0]	tb_txdata;
wire		tb_rx_valid, tb_rx_active, tb_rx_error;
wire	[7:0]	tb_rxdata;

wire	[7:0]	ep1_us_din;
wire		ep1_us_re, ep1_us_empty;
wire	[7:0]	ep3_us_din;
wire		ep3_us_re, ep3_us_empty;
wire	[7:0]	ep5_us_din;
wire		ep5_us_re, ep4_us_empty;

wire	[7:0]	ep2_us_dout;
wire		ep2_us_we, ep2_us_full;
wire	[7:0]	ep4_us_dout;
wire		ep4_us_we, ep4_us_full;


reg	[7:0]	ep1_f_din;
reg		ep1_f_we;
wire		ep1_f_full;
wire	[7:0]	ep2_f_dout;
reg		ep2_f_re;
wire		ep2_f_empty;
reg	[7:0]	ep3_f_din;
reg		ep3_f_we;
wire		ep3_f_full;
wire	[7:0]	ep4_f_dout;
reg		ep4_f_re;
wire		ep4_f_empty;
reg	[7:0]	ep5_f_din;
reg		ep5_f_we;
wire		ep5_f_full;

reg	[7:0]	ep0_max_size;
reg	[7:0]	ep1_max_size;
reg	[7:0]	ep2_max_size;
reg	[7:0]	ep3_max_size;
reg	[7:0]	ep4_max_size;
reg	[7:0]	ep5_max_size;
reg	[7:0]	ep6_max_size;
reg	[7:0]	ep7_max_size;

wire		rx_dp1;
wire		rx_dn1;
wire		tx_dp1;
wire		tx_dn1;
wire		rx_dp2;
wire		rx_dn2;
wire		tx_dp2;
wire		tx_dn2;

reg		usb_reset;
integer		n;
reg	[31:0]	data;












initial
   begin
	usb_reset = 0;
	$timeformat (-9, 1, " ns", 12);






	tb_tx_valid = 0;
	error_cnt = 0;
	wd_cnt = 0;
   	clk = 0;
   	clk2 = 0;
   	rst = 0;
	ep1_f_we=0;
	ep2_f_re=0;
	ep3_f_we=0;
	ep4_f_re=0;
	ep5_f_we=0;

   	repeat(10)	@(posedge clk);
   	rst = 1;
   	repeat(50)	@(posedge clk);
	usb_reset = 1;
   	repeat(300)	@(posedge clk);
	usb_reset = 0;
   	repeat(10)	@(posedge clk);

	if(1)
	   begin
		setup1;
		in0;
		out0;
	   end
	else
	if(1)
	   begin
		setup1;
	   end

   	repeat(500)	@(posedge clk);
   	$finish;
   end





always @(posedge clk)
	if(tx_dp1 | tx_dp2)		wd_cnt <= #1 0;
	else				wd_cnt <= #1 wd_cnt + 1;

always @(wd_cnt)
	if(wd_cnt>5000)
	   begin
		$display("\n\n*************************************\n");
		$display("ERROR: Watch Dog Counter Expired\n");
		$display("*************************************\n\n\n");
		$finish;
	   end






always #10.42 clk = ~clk;
always #10.42 clk2 = ~clk2;





	
usb_phy tb_phy(.clk(			clk			),
		.rst(			rst			),

		.phy_tx_mode(		1'b1			),
		.usb_rst(					),

		.rxd(			rx_dp1			),
		.rxdp(			rx_dp1			),
		.rxdn(			rx_dn1			),

		.txdp(			tx_dp1			),
		.txdn(			tx_dn1			),
		.txoe(						),

		.DataIn_o(		tb_rxdata		),
		.RxValid_o(		tb_rx_valid		),
		.RxActive_o(		tb_rx_active		),
		.RxError_o(		tb_rx_error		),

		.DataOut_i(		tb_txdata		),
		.TxValid_i(		tb_tx_valid		),
		.TxReady_o(		tb_tx_ready		),
		.LineState_o(					)
		);

parameter	LD = 40;

assign #(LD) rx_dp1 = !usb_reset & tx_dp2;
assign #(LD) rx_dn1 = !usb_reset & tx_dn2;

assign #(LD) rx_dp2 = !usb_reset & tx_dp1;
assign #(LD) rx_dn2 = !usb_reset & tx_dn1;

usb1_core u0(	.clk_i(			clk2			),
		.rst_i(			rst			),

		
		.phy_tx_mode(		1'b1			),
		.usb_rst(					),
		
		.usb_busy(					),
		.ep_sel(					),

		
		.dropped_frame(					),
		.misaligned_frame(				),
		.crc16_err(					),

		
		.v_set_int(					),
		.v_set_feature(					),
		.wValue(					),
		.wIndex(					),
		.vendor_data(					),

		
		.tx_dp(			tx_dp2			),
		.tx_dn(			tx_dn2			),
		.tx_oe(						),

		.rx_d(			rx_dp2			),
		.rx_dp(			rx_dp2			),
		.rx_dn(			rx_dn2			),

		
		.ep1_cfg(	 14'b01_000_000000000  |  14'b00_001_000000000  | 14'd0256		),
		
		.ep1_dout(					),
		.ep1_we(					),
		.ep1_full(		1'b0			),
		
		.ep1_din(		ep1_us_din		),
		.ep1_re(		ep1_us_re		),
		.ep1_empty(		ep1_us_empty		),
		.ep1_bf_en(		1'b0			),
		.ep1_bf_size(		7'h0			),

		
		.ep2_cfg(	 14'b01_000_000000000  |  14'b00_010_000000000 | 14'd0256		),
		
		.ep2_dout(		ep2_us_dout		),
		.ep2_we(		ep2_us_we		),
		.ep2_full(		ep2_us_full		),
		
		.ep2_din(		8'h0			),
		.ep2_re(					),
		.ep2_empty(		1'b0			),
		.ep2_bf_en(		1'b0			),
		.ep2_bf_size(		7'h0			),

		
		.ep3_cfg(	 14'b10_000_000000000 |  14'b00_001_000000000  | 14'd064		),
		
		.ep3_dout(					),
		.ep3_we(					),
		.ep3_full(		1'b0			),
		
		.ep3_din(		ep3_us_din		),
		.ep3_re(		ep3_us_re		),
		.ep3_empty(		ep3_us_empty		),
		.ep3_bf_en(		1'b0			),
		.ep3_bf_size(		7'h0			),

		
		.ep4_cfg(	 14'b10_000_000000000 |  14'b00_010_000000000 | 14'd064		),
		
		.ep4_dout(		ep4_us_dout		),
		.ep4_we(		ep4_us_we		),
		.ep4_full(		ep4_us_full		),
		
		.ep4_din(		8'h0			),
		.ep4_re(					),
		.ep4_empty(		1'b0			),
		.ep4_bf_en(		1'b0			),
		.ep4_bf_size(		7'h0			),

		
		.ep5_cfg(	 14'b00_000_000000000  |  14'b00_001_000000000  | 14'd064		),
		
		.ep5_dout(					),
		.ep5_we(					),
		.ep5_full(		1'b0			),
		
		.ep5_din(		ep5_us_din		),
		.ep5_re(		ep5_us_re		),
		.ep5_empty(		ep5_us_empty		),
		.ep5_bf_en(		1'b0			),
		.ep5_bf_size(		7'h0			),

		
		.ep6_cfg(		14'h00			),
		
		.ep6_dout(					),
		.ep6_we(					),
		.ep6_full(		1'b0			),
		
		.ep6_din(		8'h0			),
		.ep6_re(					),
		.ep6_empty(		1'b0			),
		.ep6_bf_en(		1'b0			),
		.ep6_bf_size(		7'h0			),

		
		.ep7_cfg(		14'h00			),
		
		.ep7_dout(					),
		.ep7_we(					),
		.ep7_full(		1'b0			),
		
		.ep7_din(		8'h0			),
		.ep7_re(					),
		.ep7_empty(		1'b0			),
		.ep7_bf_en(		1'b0			),
		.ep7_bf_size(		7'h0			)
		); 	


generic_fifo_sc_a #(8,9,0)
	f0(
	.clk(		clk2		),
	.rst(		rst		),
	.clr(		1'b0		),
	.din(		ep1_f_din	),
	.we(		ep1_f_we	),
	.dout(		ep1_us_din	),
	.re(		ep1_us_re	),
	.full(				),
	.empty(				),
	.full_r(	ep1_f_full	),
	.empty_r(	ep1_us_empty	),
	.full_n(			),
	.empty_n(			),
	.full_n_r(			),
	.empty_n_r(			),
	.level(				)
	);


generic_fifo_sc_a #(8,9,0)
	f1(
	.clk(		clk2		),
	.rst(		rst		),
	.clr(		1'b0		),
	.din(		ep2_us_dout	),
	.we(		ep2_us_we	),
	.dout(		ep2_f_dout	),
	.re(		ep2_f_re	),
	.full(				),
	.empty(				),
	.full_r(	ep2_us_full	),
	.empty_r(	ep2_f_empty	),
	.full_n(			),
	.empty_n(			),
	.full_n_r(			),
	.empty_n_r(			),
	.level(				)
	);


generic_fifo_sc_a #(8,9,0)
	f2(
	.clk(		clk2		),
	.rst(		rst		),
	.clr(		1'b0		),
	.din(		ep3_f_din	),
	.we(		ep3_f_we	),
	.dout(		ep3_us_din	),
	.re(		ep3_us_re	),
	.full(				),
	.empty(				),
	.full_r(	ep3_f_full	),
	.empty_r(	ep3_us_empty	),
	.full_n(			),
	.empty_n(			),
	.full_n_r(			),
	.empty_n_r(			),
	.level(				)
	);


generic_fifo_sc_a #(8,9,0)
	f3(
	.clk(		clk2		),
	.rst(		rst		),
	.clr(		1'b0		),
	.din(		ep4_us_dout	),
	.we(		ep4_us_we	),
	.dout(		ep4_f_dout	),
	.re(		ep4_f_re	),
	.full(				),
	.empty(				),
	.full_r(	ep4_us_full	),
	.empty_r(	ep4_f_empty	),
	.full_n(			),
	.empty_n(			),
	.full_n_r(			),
	.empty_n_r(			),
	.level(				)
	);


generic_fifo_sc_a #(8,6,0)
	f4(
	.clk(		clk2		),
	.rst(		rst		),
	.clr(		1'b0		),
	.din(		ep5_f_din	),
	.we(		ep5_f_we	),
	.dout(		ep5_us_din	),
	.re(		ep5_us_re	),
	.full(				),
	.empty(				),
	.full_r(	ep5_f_full	),
	.empty_r(	ep5_us_empty	),
	.full_n(			),
	.empty_n(			),
	.full_n_r(			),
	.empty_n_r(			),
	.level(				)
	);





`line 1 "C:\simulation_bench_mark\usb11\usb1_funct\bench\verilog\tests_lib.v"





























































task show_errors;

begin

$display("\n");
$display("     +--------------------+");
$display("     |  Total ERRORS: %0d   |", error_cnt);
$display("     +--------------------+");

end
endtask

task recv_packet;
output	[3:0]	pid;
output		size;

integer		del, size,n;
reg	[15:0]	crc16r;
reg	[7:0]	x,y;

begin
crc16r = 16'hffff;
utmi_recv_pack(size);
for(n=1;n<size-2;n=n+1)
   begin
	y = txmem[n];
	x[7] = y[0];
	x[6] = y[1];
	x[5] = y[2];
	x[4] = y[3];
	x[3] = y[4];
	x[2] = y[5];
	x[1] = y[6];
	x[0] = y[7];
	crc16r = crc16(crc16r, x);
   end

y = crc16r[15:8];
x[7] = y[0];
x[6] = y[1];
x[5] = y[2];
x[4] = y[3];
x[3] = y[4];
x[2] = y[5];
x[1] = y[6];
x[0] = y[7];
crc16r[15:8] = ~x;

y = crc16r[7:0];
x[7] = y[0];
x[6] = y[1];
x[5] = y[2];
x[4] = y[3];
x[3] = y[4];
x[2] = y[5];
x[1] = y[6];
x[0] = y[7];
crc16r[7:0] = ~x;

if(crc16r !== {txmem[n], txmem[n+1]})
$display("ERROR: CRC Mismatch: Expected: %h, Got: %h%h (%t)",
		crc16r, txmem[n], txmem[n+1], $time);

for(n=0;n<size-3;n=n+1)
	buffer1[buffer1_last+n] = txmem[n+1];
buffer1_last = buffer1_last+n;


x = txmem[0];

if(x[7:4] !== ~x[3:0])
$display("ERROR: Pid Checksum mismatch: Top: %h Bottom: %h (%t)",
		x[7:4], x[3:0], $time);
pid = x[3:0];
size=size-3;
end
endtask



task send_token;
input	[6:0]	fa;
input	[3:0]	ep;
input	[3:0]	pid;

reg	[15:0]	tmp_data;
reg	[10:0]	x,y;
integer		len;

begin

tmp_data = {fa, ep, 5'h0};
if(pid ==  4'b0010)	len = 1;
else				len = 3;

y = {fa, ep};
x[10] = y[4];
x[9] = y[5];
x[8] = y[6];
x[7] = y[7];
x[6] = y[8];
x[5] = y[9];
x[4] = y[10];
x[3] = y[0];
x[2] = y[1];
x[1] = y[2];
x[0] = y[3];

y[4:0]  = crc5( 5'h1f, x );
tmp_data[4:0]  = ~y[4:0];
tmp_data[15:5] = x;
txmem[0] = {~pid, pid};	
txmem[1] = {	tmp_data[8],tmp_data[9],tmp_data[10],tmp_data[11],
		tmp_data[12],tmp_data[13],tmp_data[14],tmp_data[15]};
txmem[2] = {	tmp_data[0],tmp_data[1],tmp_data[2],tmp_data[3],
		tmp_data[4],tmp_data[5],tmp_data[6],tmp_data[7]};
utmi_send_pack(len);
end
endtask


task send_sof;
input	[10:0]	frmn;

reg	[15:0]	tmp_data;
reg	[10:0]	x,y;
begin

y = frmn;
x[10] = y[0];
x[9] = y[1];
x[8] = y[2];
x[7] = y[3];
x[6] = y[4];
x[5] = y[5];
x[4] = y[6];
x[3] = y[7];
x[2] = y[8];
x[1] = y[9];
x[0] = y[10];

tmp_data[15:5] = x;
y[4:0]  = crc5( 5'h1f, x );
tmp_data[4:0]  = ~y[4:0];
txmem[0] = {~ 4'b0101,  4'b0101};	
txmem[1] = {	tmp_data[8],tmp_data[9],tmp_data[10],tmp_data[11],
		tmp_data[12],tmp_data[13],tmp_data[14],tmp_data[15]};
txmem[2] = {	tmp_data[0],tmp_data[1],tmp_data[2],tmp_data[3],
		tmp_data[4],tmp_data[5],tmp_data[6],tmp_data[7]};
txmem[1] = 	frmn[7:0];
txmem[2] = {	tmp_data[0],tmp_data[1],tmp_data[2],tmp_data[3],
		tmp_data[4], frmn[10:8] };
utmi_send_pack(3);
end
endtask


function [4:0] crc5;
input	[4:0]	crc_in;
input	[10:0]	din;
reg	[4:0]	crc_out;

begin

crc5[0] =	din[10] ^ din[9] ^ din[6] ^ din[5] ^ din[3] ^
		din[0] ^ crc_in[0] ^ crc_in[3] ^ crc_in[4];
crc5[1] =	din[10] ^ din[7] ^ din[6] ^ din[4] ^ din[1] ^
		crc_in[0] ^ crc_in[1] ^ crc_in[4];
crc5[2] =	din[10] ^ din[9] ^ din[8] ^ din[7] ^ din[6] ^
		din[3] ^ din[2] ^ din[0] ^ crc_in[0] ^ crc_in[1] ^
		crc_in[2] ^ crc_in[3] ^ crc_in[4];
crc5[3] =	din[10] ^ din[9] ^ din[8] ^ din[7] ^ din[4] ^ din[3] ^
		din[1] ^ crc_in[1] ^ crc_in[2] ^ crc_in[3] ^ crc_in[4];
crc5[4] =	din[10] ^ din[9] ^ din[8] ^ din[5] ^ din[4] ^ din[2] ^
		crc_in[2] ^ crc_in[3] ^ crc_in[4];
end
endfunction


task send_data;
input	[3:0]	pid;
input		len;
input		mode;
integer		n, len, mode, delay;
reg	[15:0]	crc16r;
reg	[7:0]	x,y;

begin
txmem[0] = {~pid, pid};	
crc16r = 16'hffff;
for(n=0;n<len;n=n+1)
   begin
	if(mode==1)	y = buffer1[buffer1_last+n];
	else		y = n;
	x[7] = y[0];
	x[6] = y[1];
	x[5] = y[2];
	x[4] = y[3];
	x[3] = y[4];
	x[2] = y[5];
	x[1] = y[6];
	x[0] = y[7];
	txmem[n+1] = y;
	crc16r = crc16(crc16r, x);
   end

buffer1_last = buffer1_last + n;
y = crc16r[15:8];
x[7] = y[0];
x[6] = y[1];
x[5] = y[2];
x[4] = y[3];
x[3] = y[4];
x[2] = y[5];
x[1] = y[6];
x[0] = y[7];
txmem[n+1] = ~x;

y = crc16r[7:0];
x[7] = y[0];
x[6] = y[1];
x[5] = y[2];
x[4] = y[3];
x[3] = y[4];
x[2] = y[5];
x[1] = y[6];
x[0] = y[7];
txmem[n+2] = ~x;
utmi_send_pack(len+3);
end
endtask


function [15:0] crc16;
input	[15:0]	crc_in;
input	[7:0]	din;
reg	[15:0]	crc_out;

begin
crc_out[0] =	din[7] ^ din[6] ^ din[5] ^ din[4] ^ din[3] ^
		din[2] ^ din[1] ^ din[0] ^ crc_in[8] ^ crc_in[9] ^
		crc_in[10] ^ crc_in[11] ^ crc_in[12] ^ crc_in[13] ^
		crc_in[14] ^ crc_in[15];
crc_out[1] =	din[7] ^ din[6] ^ din[5] ^ din[4] ^ din[3] ^ din[2] ^
		din[1] ^ crc_in[9] ^ crc_in[10] ^ crc_in[11] ^
		crc_in[12] ^ crc_in[13] ^ crc_in[14] ^ crc_in[15];
crc_out[2] =	din[1] ^ din[0] ^ crc_in[8] ^ crc_in[9];
crc_out[3] =	din[2] ^ din[1] ^ crc_in[9] ^ crc_in[10];
crc_out[4] =	din[3] ^ din[2] ^ crc_in[10] ^ crc_in[11];
crc_out[5] =	din[4] ^ din[3] ^ crc_in[11] ^ crc_in[12];
crc_out[6] =	din[5] ^ din[4] ^ crc_in[12] ^ crc_in[13];
crc_out[7] =	din[6] ^ din[5] ^ crc_in[13] ^ crc_in[14];
crc_out[8] =	din[7] ^ din[6] ^ crc_in[0] ^ crc_in[14] ^ crc_in[15];
crc_out[9] =	din[7] ^ crc_in[1] ^ crc_in[15];
crc_out[10] =	crc_in[2];
crc_out[11] =	crc_in[3];
crc_out[12] =	crc_in[4];
crc_out[13] =	crc_in[5];
crc_out[14] =	crc_in[6];
crc_out[15] =	din[7] ^ din[6] ^ din[5] ^ din[4] ^ din[3] ^ din[2] ^
		din[1] ^ din[0] ^ crc_in[7] ^ crc_in[8] ^ crc_in[9] ^
		crc_in[10] ^ crc_in[11] ^ crc_in[12] ^ crc_in[13] ^
		crc_in[14] ^ crc_in[15];
crc16 = crc_out;
end
endfunction






task utmi_send_pack;
input	size;
integer n,size;

begin
@(posedge clk);
#1;
tb_tx_valid = 1'b1;
for(n=0;n<size;n=n+1)
   begin
	tb_txdata = txmem[n];
	@(posedge clk);
	#2;
	while(!tb_tx_ready)	@(posedge clk);
	#1;
   end
tb_tx_valid = 1'b0;
@(posedge clk);
end
endtask

task utmi_recv_pack;
output	size;
integer	size;

begin
size = 0;
while(!tb_rx_active)	@(posedge clk);
while(tb_rx_active)
   begin
	#1;
	while(!tb_rx_valid & tb_rx_active)	@(posedge clk);
	
	if(tb_rx_valid & tb_rx_active)
	   begin
		txmem[size] = tb_rxdata;
		size = size + 1;
	   end
	@(posedge clk);
   end
end
endtask


`line 471 "C:\simulation_bench_mark\usb11\usb1_funct\bench\verilog\test_bench_top.v"

`line 1 "C:\simulation_bench_mark\usb11\usb1_funct\bench\verilog\tests.v"





























































task send_setup;
input	[7:0]	fa;
input	[7:0]	req_type;
input	[7:0]	request;
input	[15:0]	wValue;
input	[15:0]	wIndex;
input	[15:0]	wLength;

integer		len;
begin

buffer1[0] = req_type;
buffer1[1] = request;
buffer1[3] = wValue[15:8];
buffer1[2] = wValue[7:0];
buffer1[5] = wIndex[15:8];
buffer1[4] = wIndex[7:0];
buffer1[7] = wLength[15:8];
buffer1[6] = wLength[7:0];

buffer1_last = 0;
send_token(	fa,			
		0,			
		 4'b1101	
		);

repeat(1)	@(posedge clk);

send_data( 4'b0011, 8, 1);


utmi_recv_pack(len);

if(8'hd2 !== txmem[0])
   begin
	$display("ERROR: SETUP: ACK mismatch. Expected: %h, Got: %h (%t)",
	8'hd2, txmem[0], $time);
	error_cnt = error_cnt + 1;
   end

if(len !== 1)
   begin
	$display("ERROR: SETUP: Length mismatch. Expected: %h, Got: %h (%t)",
	8'h1, len, $time);
	error_cnt = error_cnt + 1;
   end

repeat(1)	@(posedge clk);
setup_pid = 1;
repeat(1)	@(posedge clk);
end

endtask



task data_in;
input	[7:0]	fa;
input	[7:0]	pl_size;

integer		rlen;
reg	[3:0]	pid, expect_pid;
begin

	buffer1_last = 0;
	repeat(5)	@(posedge clk);
	send_token(	fa,		
			0,		
			 4'b1001	
			);

	recv_packet(pid,rlen);
	if(setup_pid)	expect_pid = 4'hb; 
	else		expect_pid = 4'h3; 

	if(pid !== expect_pid)
	   begin
		$display("ERROR: Data IN PID mismatch. Expected: %h, Got: %h (%t)",
			expect_pid, pid, $time);
		error_cnt = error_cnt + 1;
	   end

	setup_pid = ~setup_pid;
	if(rlen != pl_size)
	   begin
		$display("ERROR: Data IN Size mismatch. Expected: %d, Got: %d (%t)",
			pl_size, rlen, $time);
		error_cnt = error_cnt + 1;
	   end

	for(n=0;n<rlen;n=n+1)
		$display("RCV Data[%0d]: %h",n,buffer1[n]);

	repeat(5)	@(posedge clk);
	send_token(	fa,		
			0,		
			 4'b0010	
			);

	repeat(5)	@(posedge clk);

end
endtask



task data_out;
input	[7:0]	fa;
input	[7:0]	pl_size;

integer len;

begin
	send_token(	fa,		
			0,		
			 4'b0001	
			);

	repeat(1)	@(posedge clk);

	if(setup_pid==0)	send_data( 4'b0011, pl_size, 1);
	else			send_data( 4'b1011, pl_size, 1);

	setup_pid = ~setup_pid;

	
	utmi_recv_pack(len);

	if(8'hd2 !== txmem[0])
	   begin
		$display("ERROR: ACK mismatch. Expected: %h, Got: %h (%t)",
		8'hd2, txmem[0], $time);
		error_cnt = error_cnt + 1;
	   end

	if(len !== 1)
	   begin
		$display("ERROR: SETUP: Length mismatch. Expected: %h, Got: %h (%t)",
		8'h1, len, $time);
		error_cnt = error_cnt + 1;
	   end
	repeat(5)	@(posedge clk);

end
endtask


parameter	GET_STATUS	=	8'h0,
		CLEAR_FEATURE	=	8'h1,
		SET_FEATURE	=	8'h3,
		SET_ADDRESS	=	8'h5,
		GET_DESCRIPTOR	=	8'h6,
		SET_DESCRIPTOR	=	8'h7,
		GET_CONFIG	=	8'h8,
		SET_CONFIG	=	8'h9,
		GET_INTERFACE	=	8'ha,
		SET_INTERFACE	=	8'hb,
		SYNCH_FRAME	=	8'hc;


task setup1;

begin
$display("\n\n");
$display("*****************************************************");
$display("*** CTRL ep test 1                                ***");
$display("*****************************************************\n");


$display("\n\nSetting Address ...");

send_setup(	8'h0, 		
		8'h00,		
		SET_ADDRESS,	
		16'h012,	
		16'h0,		
		16'h0		
		);


data_in(	8'h0,		
		8'h0		
	);


$display("\n\nGetting descriptor ...");
send_setup(	8'h12, 		
		8'h80,		
		GET_DESCRIPTOR,	
		16'h0100,	
		16'h0,		
		16'h8		
		);

data_in(	8'h12,		
		8'd08		
	);


data_out(	8'h12,		
		8'h0		
	);


$display("\n\nGetting descriptor ...");
send_setup(	8'h12, 		
		8'h80,		
		GET_DESCRIPTOR,	
		16'h0200,	
		16'h0,		
		16'h8		
		);

data_in(	8'h12,		
		8'd08		
	);


data_out(	8'h12,		
		8'h0		
	);

$display("\n\nGetting descriptor ...");
send_setup(	8'h12, 		
		8'h80,		
		GET_DESCRIPTOR,	
		16'h0200,	
		16'h0,		
		16'd053		
		);

data_in(	8'h12,		
		8'd053		
	);


data_out(	8'h12,		
		8'h0		
	);

$display("\n\nGetting descriptor ...");
send_setup(	8'h12, 		
		8'h80,		
		GET_DESCRIPTOR,	
		16'h0300,	
		16'h0,		
		16'd04		
		);

data_in(	8'h12,		
		8'd04		
	);


data_out(	8'h12,		
		8'h0		
	);

$display("\n\nGetting descriptor ...");
send_setup(	8'h12, 		
		8'h80,		
		GET_DESCRIPTOR,	
		16'h0301,	
		16'h0,		
		16'd010		
		);

data_in(	8'h12,		
		8'd010		
	);


data_out(	8'h12,		
		8'h0		
	);

$display("\n\nGetting descriptor ...");
send_setup(	8'h12, 		
		8'h80,		
		GET_DESCRIPTOR,	
		16'h0302,	
		16'h0,		
		16'd08		
		);

data_in(	8'h12,		
		8'd08		
	);


data_out(	8'h12,		
		8'h0		
	);

$display("\n\nGetting descriptor ...");
send_setup(	8'h12, 		
		8'h80,		
		GET_DESCRIPTOR,	
		16'h0303,	
		16'h0,		
		16'd016		
		);

data_in(	8'h12,		
		8'd010		
	);


data_out(	8'h12,		
		8'h0		
	);

$display("\n\nGetting descriptor ...");
send_setup(	8'h12, 		
		8'h80,		
		GET_DESCRIPTOR,	
		16'h0203,	
		16'h0,		
		16'd053		
		);

data_in(	8'h12,		
		8'd053		
	);


data_out(	8'h12,		
		8'h0		
	);

show_errors;
$display("*****************************************************");
$display("*** Test DONE ...                                 ***");
$display("*****************************************************\n\n");

end
endtask


task in0;

reg	[6:0]	my_fa;
integer		quick, n, m, rlen,fc;
reg	[7:0]	fd;
integer		pack_cnt, pack_cnt_max;
reg	[7:0]	x;
reg	[3:0]	pid;
reg	[3:0]	expect_pid;
reg	[31:0]	data;
reg		pid_cnt;

begin

$display("\n\n");
$display("*****************************************************");
$display("*** IN ep test 0                                  ***");
$display("*****************************************************\n");

send_sof(11'h000 );	

pack_sz_max = 64;
pack_cnt_max = 4;

pid_cnt = 0;
my_fa = 7'h12;

for(pack_sz=0;pack_sz<pack_sz_max;pack_sz=pack_sz+1)
begin

$display("PL size: %0d", pack_sz);

for(pack_cnt=0;pack_cnt<pack_cnt_max;pack_cnt=pack_cnt+1)
   begin

	
	buffer1_last = 0;
	for(fc=0;fc<pack_sz;fc=fc+1)
	   begin
		#2;
		while(ep1_f_full)	@(posedge clk);
	
		#1;
		
		x = $random;
		ep1_f_din = x;
		buffer0[fc] = x;
		ep1_f_we = 1;
		@(posedge clk);
		#1;
		ep1_f_we = 0;
		@(posedge clk);
	   end
	#1;
	ep1_f_we = 0;
	@(posedge clk);

	
	repeat(1)	@(posedge clk);
	send_sof(11'h000 );	
	repeat(1)	@(posedge clk);
	send_token(	my_fa,		
			1,		
			 4'b1001	
			);

	repeat(1)	@(posedge clk);

	recv_packet(pid,rlen);

	if(pid_cnt)	expect_pid = 4'hb;
	else		expect_pid = 4'h3;
	expect_pid = 4'h3;

	if(pid !== expect_pid)
	   begin
		$display("ERROR: PID mismatch. Expected: %h, Got: %h (%t)",
			expect_pid, pid, $time);
		error_cnt = error_cnt + 1;
	   end
	pid_cnt = ~pid_cnt;

	if(rlen != pack_sz)
	   begin
		$display("ERROR: Size mismatch. Expected: %d, Got: %d (%t)",
			pack_sz, rlen, $time);
		error_cnt = error_cnt + 1;
	   end

	repeat(4)	@(posedge clk);
	send_token(	my_fa,		
			1,		
			 4'b0010	
			);
	repeat(5)	@(posedge clk);

	
	for(fc=0;fc<pack_sz;fc=fc+1)
	   begin
		x =  buffer0[fc];
		if( (buffer1[fc] !== x) | ( (^buffer1[fc] ^ ^x) === 1'hx) )
		   begin
			$display("ERROR: Data (%0d) mismatch. Expected: %h, Got: %h (%t)",
			fc, buffer1[fc], x, $time);
			error_cnt = error_cnt + 1;
		   end
	   end
   end

repeat(50)	@(posedge clk);
end

show_errors;
$display("*****************************************************");
$display("*** Test DONE ...                                 ***");
$display("*****************************************************\n\n");

end

endtask

task out0;
reg	[6:0]	my_fa;
reg	[31:0]	data;
integer		len, n, no_pack, pl_sz;
integer		no_pack_max, pl_sz_max;
reg		pid;

reg	[7:0]	x;

begin
$display("\n\n");
$display("*****************************************************");
$display("*** OUT ep test 0                                 ***");
$display("*****************************************************\n");


no_pack_max = 4;	
pl_sz_max   = 128;	

no_pack = 4;		
pl_sz = 0;
my_fa = 7'h12;


for(pl_sz=0;pl_sz<pl_sz_max;pl_sz=pl_sz+4)
begin
pid = 0;

$display("PL size: %0d", pl_sz);

for(n=0;n<4096;n=n+1)
	
	buffer1[n] = n;

buffer1_last = 0;

fork
for(no_pack=0;no_pack<no_pack_max;no_pack=no_pack+1)	
   begin
	repeat(1)	@(posedge clk);
	send_sof(11'h000 );	
	repeat(1)	@(posedge clk);

	send_token(	my_fa,		
			4,		
			 4'b0001	
			);

	repeat(1)	@(posedge clk);

	if(pid==0)	send_data( 4'b0011, pl_sz, 1);
	else		send_data( 4'b1011, pl_sz, 1);

	pid = ~pid;

	
	utmi_recv_pack(len);

	if(8'hd2 !== txmem[0])
	   begin
		$display("ERROR: ACK mismatch. Expected: %h, Got: %h (%t)",
		8'hd2, txmem[0], $time);
		error_cnt = error_cnt + 1;
	   end
	
	repeat(1)	@(posedge clk);
   end

   begin
	repeat(10)	@(posedge clk2);
	for(n=0;n<(no_pack_max*pl_sz);n=n+1)	
	   begin
	
		#4;
		ep4_f_re = 0;
		repeat(1)	@(posedge clk2);

		while(ep4_f_empty)
		   begin
			ep4_f_re = 0;
			repeat(2)	@(posedge clk2);
		   end

		#2;
		if(buffer1[n] !== ep4_f_dout)
		   begin
			$display("ERROR: DATA mismatch. Expected: %h, Got: %h (%t)",
				buffer1[n], ep4_f_dout, $time);
			error_cnt = error_cnt + 1;
		   end
	
		ep4_f_re = 1;
		@(posedge clk2);
	   end
	#1;
	ep4_f_re = 0;
	@(posedge clk2);
    end

join

repeat(1)	@(posedge clk);
end

show_errors;
$display("*****************************************************");
$display("*** Test DONE ...                                 ***");
$display("*****************************************************\n\n");
end
endtask



`line 472 "C:\simulation_bench_mark\usb11\usb1_funct\bench\verilog\test_bench_top.v"


endmodule



`line 1 "C:\simulation_bench_mark\usb11\usb_phy\rtl\verilog\usb_tx_phy.v"










































































`line 1 "C:\simulation_bench_mark\usb11\generic_fifos\generic_fifos\rtl\verilog\timescale.v"
`timescale 1ns / 100ps

`line 75 "C:\simulation_bench_mark\usb11\usb_phy\rtl\verilog\usb_tx_phy.v"


module usb_tx_phy(
		clk, rst, fs_ce, phy_mode,
	
		
		txdp, txdn, txoe,	

		
		DataOut_i, TxValid_i, TxReady_o
		);

input		clk;
input		rst;
input		fs_ce;
input		phy_mode;
output		txdp, txdn, txoe;
input	[7:0]	DataOut_i;
input		TxValid_i;
output		TxReady_o;






parameter	IDLE	= 3'd0,
		SOP	= 3'h1,
		DATA	= 3'h2,
		EOP1	= 3'h3,
		EOP2	= 3'h4,
		WAIT	= 3'h5;

reg		TxReady_o;
reg	[2:0]	state, next_state;
reg		tx_ready_d;
reg		ld_sop_d;
reg		ld_data_d;
reg		ld_eop_d;
reg		tx_ip;
reg		tx_ip_sync;
reg	[2:0]	bit_cnt;
reg	[7:0]	hold_reg;
reg	[7:0]	hold_reg_d;

reg		sd_raw_o;
wire		hold;
reg		data_done;
reg		sft_done;
reg		sft_done_r;
wire		sft_done_e;
reg		ld_data;
wire		eop_done;
reg	[2:0]	one_cnt;
wire		stuff;
reg		sd_bs_o;
reg		sd_nrzi_o;
reg		append_eop;
reg		append_eop_sync1;
reg		append_eop_sync2;
reg		append_eop_sync3;
reg		append_eop_sync4;
reg		txdp, txdn;
reg		txoe_r1, txoe_r2;
reg		txoe;









always @(posedge clk)

	if(!rst)	TxReady_o <= 1'b0;
	else		TxReady_o <= tx_ready_d & TxValid_i;

always @(posedge clk) ld_data <= ld_data_d;









always @(posedge clk)

	if(!rst)	tx_ip <= 1'b0;
	else
	if(ld_sop_d)	tx_ip <= 1'b1;
	else
	if(eop_done)	tx_ip <= 1'b0;




always @(posedge clk)

	if(!rst)		tx_ip_sync <= 1'b0;
	else
	if(fs_ce)		tx_ip_sync <= tx_ip;








always @(posedge clk)

	if(!rst)			data_done <= 1'b0;
	else
	if(TxValid_i && ! tx_ip)	data_done <= 1'b1;
	else
	if(!TxValid_i)			data_done <= 1'b0;









always @(posedge clk)

	if(!rst)		bit_cnt <= 3'h0;
	else
	if(!tx_ip_sync)		bit_cnt <= 3'h0;
	else
	if(fs_ce && !hold)	bit_cnt <= bit_cnt + 3'h1;

assign hold = stuff;

always @(posedge clk)
	if(!tx_ip_sync)		sd_raw_o <= 1'b0;
	else
	case(bit_cnt)	
	   3'h0: sd_raw_o <= hold_reg_d[0];
	   3'h1: sd_raw_o <= hold_reg_d[1];
	   3'h2: sd_raw_o <= hold_reg_d[2];
	   3'h3: sd_raw_o <= hold_reg_d[3];
	   3'h4: sd_raw_o <= hold_reg_d[4];
	   3'h5: sd_raw_o <= hold_reg_d[5];
	   3'h6: sd_raw_o <= hold_reg_d[6];
	   3'h7: sd_raw_o <= hold_reg_d[7];
	endcase

always @(posedge clk)
	sft_done <= !hold & (bit_cnt == 3'h7);

always @(posedge clk)
	sft_done_r <= sft_done;

assign sft_done_e = sft_done & !sft_done_r;


always @(posedge clk)
	if(ld_sop_d)	hold_reg <= 8'h80;
	else
	if(ld_data)	hold_reg <= DataOut_i;

always @(posedge clk) hold_reg_d <= hold_reg;









always @(posedge clk)

	if(!rst)	one_cnt <= 3'h0;
	else
	if(!tx_ip_sync)	one_cnt <= 3'h0;
	else
	if(fs_ce)
	   begin
		if(!sd_raw_o || stuff)	one_cnt <= 3'h0;
		else			one_cnt <= one_cnt + 3'h1;
	   end

assign stuff = (one_cnt==3'h6);




always @(posedge clk)

	if(!rst)	sd_bs_o <= 1'h0;
	else
	if(fs_ce)	sd_bs_o <= !tx_ip_sync ? 1'b0 : (stuff ? 1'b0 : sd_raw_o);









always @(posedge clk)

	if(!rst)			sd_nrzi_o <= 1'b1;
	else
	if(!tx_ip_sync || !txoe_r1)	sd_nrzi_o <= 1'b1;
	else
	if(fs_ce)			sd_nrzi_o <= sd_bs_o ? sd_nrzi_o : ~sd_nrzi_o;









always @(posedge clk)

	if(!rst)		append_eop <= 1'b0;
	else
	if(ld_eop_d)		append_eop <= 1'b1;
	else
	if(append_eop_sync2)	append_eop <= 1'b0;




always @(posedge clk)

	if(!rst)	append_eop_sync1 <= 1'b0;
	else
	if(fs_ce)	append_eop_sync1 <= append_eop;




always @(posedge clk)

	if(!rst)	append_eop_sync2 <= 1'b0;
	else
	if(fs_ce)	append_eop_sync2 <= append_eop_sync1;




always @(posedge clk)

	if(!rst)	append_eop_sync3 <= 1'b0;
	else
	if(fs_ce)	append_eop_sync3 <= append_eop_sync2 |
			(append_eop_sync3 & !append_eop_sync4);	




always @(posedge clk)

	if(!rst)	append_eop_sync4 <= 1'b0;
	else
	if(fs_ce)	append_eop_sync4 <= append_eop_sync3;

assign eop_done = append_eop_sync3;









always @(posedge clk)

	if(!rst)	txoe_r1 <= 1'b0;
	else
	if(fs_ce)	txoe_r1 <= tx_ip_sync;




always @(posedge clk)

	if(!rst)	txoe_r2 <= 1'b0;
	else
	if(fs_ce)	txoe_r2 <= txoe_r1;




always @(posedge clk)

	if(!rst)	txoe <= 1'b1;
	else
	if(fs_ce)	txoe <= !(txoe_r1 | txoe_r2);









always @(posedge clk)

	if(!rst)	txdp <= 1'b1;
	else
	if(fs_ce)	txdp <= phy_mode ?
					(!append_eop_sync3 &  sd_nrzi_o) :
					sd_nrzi_o;




always @(posedge clk)

	if(!rst)	txdn <= 1'b0;
	else
	if(fs_ce)	txdn <= phy_mode ?
					(!append_eop_sync3 & ~sd_nrzi_o) :
					append_eop_sync3;









always @(posedge clk)

	if(!rst)	state <= IDLE;
	else		state <= next_state;

always @(state or TxValid_i or data_done or sft_done_e or eop_done or fs_ce)
   begin
	next_state = state;
	tx_ready_d = 1'b0;

	ld_sop_d = 1'b0;
	ld_data_d = 1'b0;
	ld_eop_d = 1'b0;

	case(state)	
	   IDLE:
			if(TxValid_i)
			   begin
				ld_sop_d = 1'b1;
				next_state = SOP;
			   end
	   SOP:
			if(sft_done_e)
			   begin
				tx_ready_d = 1'b1;
				ld_data_d = 1'b1;
				next_state = DATA;
			   end
	   DATA:
		   begin
			if(!data_done && sft_done_e)
			   begin
				ld_eop_d = 1'b1;
				next_state = EOP1;
			   end
			
			if(data_done && sft_done_e)
			   begin
				tx_ready_d = 1'b1;
				ld_data_d = 1'b1;
			   end
		   end
	   EOP1:
			if(eop_done)		next_state = EOP2;
	   EOP2:
			if(!eop_done && fs_ce)	next_state = WAIT;
	   WAIT:
			if(fs_ce)		next_state = IDLE;
	endcase
   end

endmodule



`line 1 "C:\simulation_bench_mark\usb11\usb_phy\rtl\verilog\usb_phy.v"










































































`line 1 "C:\simulation_bench_mark\usb11\generic_fifos\generic_fifos\rtl\verilog\timescale.v"
`timescale 1ns / 100ps

`line 75 "C:\simulation_bench_mark\usb11\usb_phy\rtl\verilog\usb_phy.v"


module usb_phy(clk, rst, phy_tx_mode, usb_rst,
	
		
		txdp, txdn, txoe,	
		rxd, rxdp, rxdn,

		
		DataOut_i, TxValid_i, TxReady_o, RxValid_o,
		RxActive_o, RxError_o, DataIn_o, LineState_o
		);

input		clk;
input		rst;
input		phy_tx_mode;
output		usb_rst;
output		txdp, txdn, txoe;
input		rxd, rxdp, rxdn;
input	[7:0]	DataOut_i;
input		TxValid_i;
output		TxReady_o;
output	[7:0]	DataIn_o;
output		RxValid_o;
output		RxActive_o;
output		RxError_o;
output	[1:0]	LineState_o;






reg	[4:0]	rst_cnt;
reg		usb_rst;
wire		fs_ce;
wire		rst;











usb_tx_phy i_tx_phy(
	.clk(		clk		),
	.rst(		rst		),
	.fs_ce(		fs_ce		),
	.phy_mode(	phy_tx_mode	),

	
	.txdp(		txdp		),
	.txdn(		txdn		),
	.txoe(		txoe		),

	
	.DataOut_i(	DataOut_i	),
	.TxValid_i(	TxValid_i	),
	.TxReady_o(	TxReady_o	)
	);






usb_rx_phy i_rx_phy(
	.clk(		clk		),
	.rst(		rst		),
	.fs_ce(		fs_ce		),

	
	.rxd(		rxd		),
	.rxdp(		rxdp		),
	.rxdn(		rxdn		),

	
	.DataIn_o(	DataIn_o	),
	.RxValid_o(	RxValid_o	),
	.RxActive_o(	RxActive_o	),
	.RxError_o(	RxError_o	),
	.RxEn_i(	txoe		),
	.LineState(	LineState_o	)
	);









always @(posedge clk)

	if(!rst)			rst_cnt <= 5'h0;
	else
	if(LineState_o != 2'h0)		rst_cnt <= 5'h0;
	else	
	if(!usb_rst && fs_ce)		rst_cnt <= rst_cnt + 5'h1;

always @(posedge clk)
	usb_rst <= (rst_cnt == 5'h1f);

endmodule



`line 1 "C:\simulation_bench_mark\usb11\usb_phy\rtl\verilog\usb_rx_phy.v"












































































`line 1 "C:\simulation_bench_mark\usb11\generic_fifos\generic_fifos\rtl\verilog\timescale.v"
`timescale 1ns / 100ps

`line 77 "C:\simulation_bench_mark\usb11\usb_phy\rtl\verilog\usb_rx_phy.v"


module usb_rx_phy(	clk, rst, fs_ce,
	
			
			rxd, rxdp, rxdn,

			
			RxValid_o, RxActive_o, RxError_o, DataIn_o,
			RxEn_i, LineState);

input		clk;
input		rst;
output		fs_ce;
input		rxd, rxdp, rxdn;
output	[7:0]	DataIn_o;
output		RxValid_o;
output		RxActive_o;
output		RxError_o;
input		RxEn_i;
output	[1:0]	LineState;






reg		rxd_s0, rxd_s1,  rxd_s;
reg		rxdp_s0, rxdp_s1, rxdp_s, rxdp_s_r;
reg		rxdn_s0, rxdn_s1, rxdn_s, rxdn_s_r;
reg		synced_d;
wire		k, j, se0;
reg		rxd_r;
reg		rx_en;
reg		rx_active;
reg	[2:0]	bit_cnt;
reg		rx_valid1, rx_valid;
reg		shift_en;
reg		sd_r;
reg		sd_nrzi;
reg	[7:0]	hold_reg;
wire		drop_bit;	
reg	[2:0]	one_cnt;

reg	[1:0]	dpll_state, dpll_next_state;
reg		fs_ce_d;
reg		fs_ce;
wire		change;
wire		lock_en;
reg	[2:0]	fs_state, fs_next_state;
reg		rx_valid_r;
reg		sync_err_d, sync_err;
reg		bit_stuff_err;
reg		se0_r, byte_err;
reg		se0_s;






assign RxActive_o = rx_active;
assign RxValid_o = rx_valid;
assign RxError_o = sync_err | bit_stuff_err | byte_err;
assign DataIn_o = hold_reg;
assign LineState = {rxdn_s1, rxdp_s1};

always @(posedge clk)	rx_en <= RxEn_i;
always @(posedge clk)	sync_err <= !rx_active & sync_err_d;











always @(posedge clk)	rxd_s0  <= rxd;
always @(posedge clk)	rxd_s1  <= rxd_s0;
always @(posedge clk)							
	if(rxd_s0 && rxd_s1)	rxd_s <= 1'b1;
	else
	if(!rxd_s0 && !rxd_s1)	rxd_s <= 1'b0;

always @(posedge clk)	rxdp_s0  <= rxdp;
always @(posedge clk)	rxdp_s1  <= rxdp_s0;
always @(posedge clk)	rxdp_s_r <= rxdp_s0 & rxdp_s1;
always @(posedge clk)	rxdp_s   <= (rxdp_s0 & rxdp_s1) | rxdp_s_r;	

always @(posedge clk)	rxdn_s0  <= rxdn;
always @(posedge clk)	rxdn_s1  <= rxdn_s0;
always @(posedge clk)	rxdn_s_r <= rxdn_s0 & rxdn_s1;
always @(posedge clk)	rxdn_s   <= (rxdn_s0 & rxdn_s1) | rxdn_s_r;	

assign k = !rxdp_s &  rxdn_s;
assign j =  rxdp_s & !rxdn_s;
assign se0 = !rxdp_s & !rxdn_s;

always @(posedge clk)	if(fs_ce)	se0_s <= se0;
















assign	lock_en = rx_en;

always @(posedge clk)	rxd_r <= rxd_s;


assign change = rxd_r != rxd_s;





always @(posedge clk)

	if(!rst)	dpll_state <= 2'h1;
	else		dpll_state <= dpll_next_state;

always @(dpll_state or lock_en or change)
   begin
	fs_ce_d = 1'b0;
	case(dpll_state)	
	   2'h0:
		if(lock_en && change)	dpll_next_state = 2'h0;
		else			dpll_next_state = 2'h1;
	   2'h1:begin
		fs_ce_d = 1'b1;
		if(lock_en && change)	dpll_next_state = 2'h3;
		else			dpll_next_state = 2'h2;
		end
	   2'h2:
		if(lock_en && change)	dpll_next_state = 2'h0;
		else			dpll_next_state = 2'h3;
	   2'h3:
		if(lock_en && change)	dpll_next_state = 2'h0;
		else			dpll_next_state = 2'h0;
	endcase
   end



reg	fs_ce_r1, fs_ce_r2;

always @(posedge clk)	fs_ce_r1 <= fs_ce_d;
always @(posedge clk)	fs_ce_r2 <= fs_ce_r1;
always @(posedge clk)	fs_ce <= fs_ce_r2;







parameter	FS_IDLE	= 3'h0,
		K1	= 3'h1,
		J1	= 3'h2,
		K2	= 3'h3,
		J2	= 3'h4,
		K3	= 3'h5,
		J3	= 3'h6,
		K4	= 3'h7;




always @(posedge clk)

	if(!rst)	fs_state <= FS_IDLE;
	else		fs_state <= fs_next_state;

always @(fs_state or fs_ce or k or j or rx_en or rx_active or se0 or se0_s)
   begin
	synced_d = 1'b0;
	sync_err_d = 1'b0;
	fs_next_state = fs_state;
	if(fs_ce && !rx_active && !se0 && !se0_s)
	   case(fs_state)	
		FS_IDLE:
		     begin
			if(k && rx_en)	fs_next_state = K1;
		     end
		K1:
		     begin
			if(j && rx_en)	fs_next_state = J1;
			else
			   begin
					sync_err_d = 1'b1;
					fs_next_state = FS_IDLE;
			   end
		     end
		J1:
		     begin
			if(k && rx_en)	fs_next_state = K2;
			else
			   begin
					sync_err_d = 1'b1;
					fs_next_state = FS_IDLE;
			   end
		     end
		K2:
		     begin
			if(j && rx_en)	fs_next_state = J2;
			else
			   begin
					sync_err_d = 1'b1;
					fs_next_state = FS_IDLE;
			   end
		     end
		J2:
		     begin
			if(k && rx_en)	fs_next_state = K3;
			else
			   begin
					sync_err_d = 1'b1;
					fs_next_state = FS_IDLE;
			   end
		     end
		K3:
		     begin
			if(j && rx_en)	fs_next_state = J3;
			else
			if(k && rx_en)
			   begin
					fs_next_state = FS_IDLE;	
					synced_d = 1'b1;
			   end
			else
			   begin
					sync_err_d = 1'b1;
					fs_next_state = FS_IDLE;
			   end
		     end
		J3:
		     begin
			if(k && rx_en)	fs_next_state = K4;
			else
			   begin
					sync_err_d = 1'b1;
					fs_next_state = FS_IDLE;
			   end
		     end
		K4:
		     begin
			if(k)	synced_d = 1'b1;
			fs_next_state = FS_IDLE;
		     end
	   endcase
   end









always @(posedge clk)

	if(!rst)		rx_active <= 1'b0;
	else
	if(synced_d && rx_en)	rx_active <= 1'b1;
	else
	if(se0 && rx_valid_r)	rx_active <= 1'b0;

always @(posedge clk)
	if(rx_valid)	rx_valid_r <= 1'b1;
	else
	if(fs_ce)	rx_valid_r <= 1'b0;






always @(posedge clk)
	if(fs_ce)	sd_r <= rxd_s;




always @(posedge clk)

	if(!rst)		sd_nrzi <= 1'b0;
	else
	if(!rx_active)		sd_nrzi <= 1'b1;
	else
	if(rx_active && fs_ce)	sd_nrzi <= !(rxd_s ^ sd_r);









always @(posedge clk)

	if(!rst)	one_cnt <= 3'h0;
	else
	if(!shift_en)	one_cnt <= 3'h0;
	else
	if(fs_ce)
	   begin
		if(!sd_nrzi || drop_bit)	one_cnt <= 3'h0;
		else				one_cnt <= one_cnt + 3'h1;
	   end

assign drop_bit = (one_cnt==3'h6);

always @(posedge clk)	bit_stuff_err <= drop_bit & sd_nrzi & fs_ce & !se0 & rx_active; 






always @(posedge clk)
	if(fs_ce)	shift_en <= synced_d | rx_active;

always @(posedge clk)
	if(fs_ce && shift_en && !drop_bit)
		hold_reg <= {sd_nrzi, hold_reg[7:1]};









always @(posedge clk)

	if(!rst)		bit_cnt <= 3'b0;
	else
	if(!shift_en)		bit_cnt <= 3'h0;
	else
	if(fs_ce && !drop_bit)	bit_cnt <= bit_cnt + 3'h1;




always @(posedge clk)

	if(!rst)					rx_valid1 <= 1'b0;
	else
	if(fs_ce && !drop_bit && (bit_cnt==3'h7))	rx_valid1 <= 1'b1;
	else
	if(rx_valid1 && fs_ce && !drop_bit)		rx_valid1 <= 1'b0;

always @(posedge clk)	rx_valid <= !drop_bit & rx_valid1 & fs_ce;

always @(posedge clk)	se0_r <= se0;

always @(posedge clk)	byte_err <= se0 & !se0_r & (|bit_cnt[2:1]) & rx_active;

endmodule



`line 1 "C:\simulation_bench_mark\usb11\usb_phy\rtl\verilog\timescale.v"
`timescale 1ns / 10ps


`line 1 "C:\simulation_bench_mark\usb11\generic_fifos\generic_fifos\rtl\verilog\timescale.v"
`timescale 1ns / 100ps


`line 1 "C:\simulation_bench_mark\usb11\generic_fifos\generic_fifos\rtl\verilog\generic_fifo_dc_gray.v"
































































`line 1 "C:\simulation_bench_mark\usb11\generic_fifos\generic_fifos\rtl\verilog\timescale.v"
`timescale 1ns / 100ps

`line 65 "C:\simulation_bench_mark\usb11\generic_fifos\generic_fifos\rtl\verilog\generic_fifo_dc_gray.v"





























































module generic_fifo_dc_gray(	rd_clk, wr_clk, rst, clr, din, we,
		dout, re, full, empty, wr_level, rd_level );

parameter dw=16;
parameter aw=8;

input			rd_clk, wr_clk, rst, clr;
input	[dw-1:0]	din;
input			we;
output	[dw-1:0]	dout;
input			re;
output			full; 
output			empty;
output	[1:0]		wr_level;
output	[1:0]		rd_level;






reg	[aw:0]		wp_bin, wp_gray;
reg	[aw:0]		rp_bin, rp_gray;
reg	[aw:0]		wp_s, rp_s;
reg			full, empty;

wire	[aw:0]		wp_bin_next, wp_gray_next;
wire	[aw:0]		rp_bin_next, rp_gray_next;

wire	[aw:0]		wp_bin_x, rp_bin_x;
reg	[aw-1:0]	d1, d2;

reg			rd_rst, wr_rst;
reg			rd_rst_r, wr_rst_r;
reg			rd_clr, wr_clr;
reg			rd_clr_r, wr_clr_r;






always @(posedge rd_clk or negedge rst)
	if(!rst)	rd_rst <= 1'b0;
	else
	if(rd_rst_r)	rd_rst <= 1'b1;		

always @(posedge rd_clk or negedge rst)
	if(!rst)	rd_rst_r <= 1'b0;
	else		rd_rst_r <= 1'b1;

always @(posedge wr_clk or negedge rst)
	if(!rst)	wr_rst <= 1'b0;
	else
	if(wr_rst_r)	wr_rst <= 1'b1;		

always @(posedge wr_clk or negedge rst)
	if(!rst)	wr_rst_r <= 1'b0;
	else		wr_rst_r <= 1'b1;

always @(posedge rd_clk or posedge clr)
	if(clr)		rd_clr <= 1'b1;
	else
	if(!rd_clr_r)	rd_clr <= 1'b0;		

always @(posedge rd_clk or posedge clr)
	if(clr)		rd_clr_r <= 1'b1;
	else		rd_clr_r <= 1'b0;

always @(posedge wr_clk or posedge clr)
	if(clr)		wr_clr <= 1'b1;
	else
	if(!wr_clr_r)	wr_clr <= 1'b0;		

always @(posedge wr_clk or posedge clr)
	if(clr)		wr_clr_r <= 1'b1;
	else		wr_clr_r <= 1'b0;






generic_dpram  #(aw,dw) u0(
	.rclk(		rd_clk		),
	.rrst(		!rd_rst		),
	.rce(		1'b1		),
	.oe(		1'b1		),
	.raddr(		rp_bin[aw-1:0]	),
	.do(		dout		),
	.wclk(		wr_clk		),
	.wrst(		!wr_rst		),
	.wce(		1'b1		),
	.we(		we		),
	.waddr(		wp_bin[aw-1:0]	),
	.di(		din		)
	);






always @(posedge wr_clk)
	if(!wr_rst)	wp_bin <= {aw+1{1'b0}};
	else
	if(wr_clr)	wp_bin <= {aw+1{1'b0}};
	else
	if(we)		wp_bin <= wp_bin_next;

always @(posedge wr_clk)
	if(!wr_rst)	wp_gray <= {aw+1{1'b0}};
	else
	if(wr_clr)	wp_gray <= {aw+1{1'b0}};
	else
	if(we)		wp_gray <= wp_gray_next;

assign wp_bin_next  = wp_bin + {{aw{1'b0}},1'b1};
assign wp_gray_next = wp_bin_next ^ {1'b0, wp_bin_next[aw:1]};

always @(posedge rd_clk)
	if(!rd_rst)	rp_bin <= {aw+1{1'b0}};
	else
	if(rd_clr)	rp_bin <= {aw+1{1'b0}};
	else
	if(re)		rp_bin <= rp_bin_next;

always @(posedge rd_clk)
	if(!rd_rst)	rp_gray <= {aw+1{1'b0}};
	else
	if(rd_clr)	rp_gray <= {aw+1{1'b0}};
	else
	if(re)		rp_gray <= rp_gray_next;

assign rp_bin_next  = rp_bin + {{aw{1'b0}},1'b1};
assign rp_gray_next = rp_bin_next ^ {1'b0, rp_bin_next[aw:1]};







always @(posedge rd_clk)	wp_s <= wp_gray;


always @(posedge wr_clk)	rp_s <= rp_gray;






assign wp_bin_x = wp_s ^ {1'b0, wp_bin_x[aw:1]};	
assign rp_bin_x = rp_s ^ {1'b0, rp_bin_x[aw:1]};	

always @(posedge rd_clk)
        empty <= (wp_s == rp_gray) | (re & (wp_s == rp_gray_next));

always @(posedge wr_clk)
        full <= ((wp_bin[aw-1:0] == rp_bin_x[aw-1:0]) & (wp_bin[aw] != rp_bin_x[aw])) |
        (we & (wp_bin_next[aw-1:0] == rp_bin_x[aw-1:0]) & (wp_bin_next[aw] != rp_bin_x[aw]));





reg	[1:0]		wr_level;
reg	[1:0]		rd_level;
reg	[aw-1:0]	wp_bin_xr, rp_bin_xr;
reg			full_rc;
reg			full_wc;

always @(posedge wr_clk)	full_wc <= full;
always @(posedge wr_clk)	rp_bin_xr <=  ~rp_bin_x[aw-1:0] + {{aw-1{1'b0}}, 1'b1};
always @(posedge wr_clk)	d1 <= wp_bin[aw-1:0] + rp_bin_xr[aw-1:0];

always @(posedge wr_clk)	wr_level <= {d1[aw-1] | full | full_wc, d1[aw-2] | full | full_wc};

always @(posedge rd_clk)	wp_bin_xr <=  ~wp_bin_x[aw-1:0];
always @(posedge rd_clk)	d2 <= rp_bin[aw-1:0] + wp_bin_xr[aw-1:0];

always @(posedge rd_clk)	full_rc <= full;
always @(posedge rd_clk)	rd_level <= full_rc ? 2'h0 : {d2[aw-1] | empty, d2[aw-2] | empty};







always @(posedge wr_clk)
	if(we && full)
		$display("%m WARNING: Writing while fifo is FULL (%t)",$time);

always @(posedge rd_clk)
	if(re && empty)
		$display("%m WARNING: Reading while fifo is EMPTY (%t)",$time);


endmodule



`line 1 "C:\simulation_bench_mark\usb11\generic_fifos\generic_fifos\rtl\verilog\generic_fifo_lfsr.v"



















































`line 1 "C:\simulation_bench_mark\usb11\generic_fifos\generic_fifos\rtl\verilog\timescale.v"
`timescale 1ns / 100ps

`line 52 "C:\simulation_bench_mark\usb11\generic_fifos\generic_fifos\rtl\verilog\generic_fifo_lfsr.v"











module generic_fifo_lfsr (
	clk,
	nReset,
	rst,
	wreq,
	rreq,
	d,
	q,
	empty,
	full,
	aempty,
	afull
	);

	
	
	
	parameter aw =  3;                         
	parameter dw =  8;                         

	
	
	
	input             clk;                     
	input nReset;                              
	input rst;                                 

	input             wreq;                    
	input             rreq;                    
	input  [dw:1] d;                           
	output [dw:1] q;                           

	output            empty;                   
	output            full;                    

	output            aempty;                  
	output            afull;                   

	reg empty, full;

	
	
	
	reg  [aw:1] rp, wp;
	wire [dw:1] ramq;
	wire fwreq, frreq;


	function lsb;
	   input [aw:1] q;
	   case (aw)
	       2: lsb = ~q[2];
	       3: lsb = &q[aw-1:1] ^ ~(q[3] ^ q[2]);
	       4: lsb = &q[aw-1:1] ^ ~(q[4] ^ q[3]);
	       5: lsb = &q[aw-1:1] ^ ~(q[5] ^ q[3]);
	       6: lsb = &q[aw-1:1] ^ ~(q[6] ^ q[5]);
	       7: lsb = &q[aw-1:1] ^ ~(q[7] ^ q[6]);
	       8: lsb = &q[aw-1:1] ^ ~(q[8] ^ q[6] ^ q[5] ^ q[4]);
	       9: lsb = &q[aw-1:1] ^ ~(q[9] ^ q[5]);
	      10: lsb = &q[aw-1:1] ^ ~(q[10] ^ q[7]);
	      11: lsb = &q[aw-1:1] ^ ~(q[11] ^ q[9]);
	      12: lsb = &q[aw-1:1] ^ ~(q[12] ^ q[6] ^ q[4] ^ q[1]);
	      13: lsb = &q[aw-1:1] ^ ~(q[13] ^ q[4] ^ q[3] ^ q[1]);
	      14: lsb = &q[aw-1:1] ^ ~(q[14] ^ q[5] ^ q[3] ^ q[1]);
	      15: lsb = &q[aw-1:1] ^ ~(q[15] ^ q[14]);
	      16: lsb = &q[aw-1:1] ^ ~(q[16] ^ q[15] ^ q[13] ^ q[4]);
	   endcase
	endfunction



























  assign fwreq = wreq;
  assign frreq = rreq;


	
	always @(posedge clk or negedge nReset)
	  if (~nReset)    rp <= #1 0;
	  else if (rst)   rp <= #1 0;
	  else if (frreq) rp <= #1 {rp[aw-1:1], lsb(rp)};

	
	always @(posedge clk or negedge nReset)
	  if (~nReset)    wp <= #1 0;
	  else if (rst)   wp <= #1 0;
	  else if (fwreq) wp <= #1 {wp[aw-1:1], lsb(wp)};

	
	generic_dpram #(aw, dw)
	fiforam (
		
		.wclk(clk),
		.wrst(1'b0),
		.wce(1'b1),
		.we(fwreq),
		.waddr(wp),
		.di(d),

		
		.rclk(clk),
		.rrst(1'b0),
		.rce(1'b1),
		.oe(1'b1),
		.raddr(rp),
		.do(q)
	);

	
	assign aempty = (rp[aw-1:1] == wp[aw:2]) & (lsb(rp) == wp[1]) & frreq & ~fwreq;
	always @(posedge clk or negedge nReset)
	  if (~nReset)
	    empty <= #1 1'b1;
	  else if (rst)
	    empty <= #1 1'b1;
	  else
	    empty <= #1 aempty | (empty & (~fwreq + frreq));

	assign afull = (wp[aw-1:1] == rp[aw:2]) & (lsb(wp) == rp[1]) & fwreq & ~frreq;
	always @(posedge clk or negedge nReset)
	  if (~nReset)
	    full <= #1 1'b0;
	  else if (rst)
	    full <= #1 1'b0;
	  else
	    full <= #1 afull | ( full & (~frreq + fwreq) );

	
	
	
	
	always @(posedge clk)
	  if (full & fwreq)
	    $display("Writing while FIFO full\n");

	always @(posedge clk)
	  if (empty & frreq)
	    $display("Reading while FIFO empty\n");
	
endmodule



`line 1 "C:\simulation_bench_mark\usb11\generic_fifos\generic_fifos\rtl\verilog\generic_fifo_sc_a.v"
































































`line 1 "C:\simulation_bench_mark\usb11\generic_fifos\generic_fifos\rtl\verilog\timescale.v"
`timescale 1ns / 100ps

`line 65 "C:\simulation_bench_mark\usb11\generic_fifos\generic_fifos\rtl\verilog\generic_fifo_sc_a.v"


















































































module generic_fifo_sc_a(clk, rst, clr, din, we, dout, re,
			full, empty, full_r, empty_r,
			full_n, empty_n, full_n_r, empty_n_r,
			level);

parameter dw=8;
parameter aw=8;
parameter n=32;
parameter max_size = 1<<aw;

input			clk, rst, clr;
input	[dw-1:0]	din;
input			we;
output	[dw-1:0]	dout;
input			re;
output			full, full_r;
output			empty, empty_r;
output			full_n, full_n_r;
output			empty_n, empty_n_r;
output	[1:0]		level;






reg	[aw-1:0]	wp;
wire	[aw-1:0]	wp_pl1;
wire	[aw-1:0]	wp_pl2;
reg	[aw-1:0]	rp;
wire	[aw-1:0]	rp_pl1;
reg			full_r;
reg			empty_r;
reg			gb;
reg			gb2;
reg	[aw:0]		cnt;
wire			full_n, empty_n;
reg			full_n_r, empty_n_r;






generic_dpram  #(aw,dw) u0(
	.rclk(		clk		),
	.rrst(		!rst		),
	.rce(		1'b1		),
	.oe(		1'b1		),
	.raddr(		rp		),
	.do(		dout		),
	.wclk(		clk		),
	.wrst(		!rst		),
	.wce(		1'b1		),
	.we(		we		),
	.waddr(		wp		),
	.di(		din		)
	);






always @(posedge clk )
	if(!rst)	wp <= #1 {aw{1'b0}};
	else
	if(clr)		wp <= #1 {aw{1'b0}};
	else
	if(we)		wp <= #1 wp_pl1;

assign wp_pl1 = wp + { {aw-1{1'b0}}, 1'b1};
assign wp_pl2 = wp + { {aw-2{1'b0}}, 2'b10};

always @(posedge clk )
	if(!rst)	rp <= #1 {aw{1'b0}};
	else
	if(clr)		rp <= #1 {aw{1'b0}};
	else
	if(re)		rp <= #1 rp_pl1;

assign rp_pl1 = rp + { {aw-1{1'b0}}, 1'b1};






assign empty = ((wp == rp) & !gb);
assign full  = ((wp == rp) &  gb);


always @(posedge clk )
	if(!rst)			gb <= #1 1'b0;
	else
	if(clr)				gb <= #1 1'b0;
	else
	if((wp_pl1 == rp) & we)		gb <= #1 1'b1;
	else
	if(re)				gb <= #1 1'b0;







always @(posedge clk )
	if(!rst)			gb2 <= #1 1'b0;
	else
	if(clr)				gb2 <= #1 1'b0;
	else
	if((wp_pl2 == rp) & we)		gb2 <= #1 1'b1;
	else
	if((wp != rp) & re)		gb2 <= #1 1'b0;

always @(posedge clk )
	if(!rst)				full_r <= #1 1'b0;
	else
	if(clr)					full_r <= #1 1'b0;
	else
	if(we & ((wp_pl1 == rp) & gb2) & !re)	full_r <= #1 1'b1;
	else
	if(re & ((wp_pl1 != rp) | !gb2) & !we)	full_r <= #1 1'b0;

always @(posedge clk )
	if(!rst)				empty_r <= #1 1'b1;
	else
	if(clr)					empty_r <= #1 1'b1;
	else
	if(we & ((wp != rp_pl1) | gb2) & !re)	empty_r <= #1 1'b0;
	else
	if(re & ((wp == rp_pl1) & !gb2) & !we)	empty_r <= #1 1'b1;






assign empty_n = cnt < n;
assign full_n  = !(cnt < (max_size-n+1));
assign level = {2{cnt[aw]}} | cnt[aw-1:aw-2];


always @(posedge clk )
	if(!rst)	cnt <= #1 {aw+1{1'b0}};
	else
	if(clr)		cnt <= #1 {aw+1{1'b0}};
	else
	if( re & !we)	cnt <= #1 cnt + { {aw{1'b1}}, 1'b1};
	else
	if(!re &  we)	cnt <= #1 cnt + { {aw{1'b0}}, 1'b1};






always @(posedge clk )
	if(!rst)				empty_n_r <= #1 1'b1;
	else
	if(clr)					empty_n_r <= #1 1'b1;
	else
	if(we & (cnt >= (n-1) ) & !re)		empty_n_r <= #1 1'b0;
	else
	if(re & (cnt <= n ) & !we)		empty_n_r <= #1 1'b1;

always @(posedge clk )
	if(!rst)				full_n_r <= #1 1'b0;
	else
	if(clr)					full_n_r <= #1 1'b0;
	else
	if(we & (cnt >= (max_size-n) ) & !re)	full_n_r <= #1 1'b1;
	else
	if(re & (cnt <= (max_size-n+1)) & !we)	full_n_r <= #1 1'b0;







always @(posedge clk)
	if(we & full)
		$display("%m WARNING: Writing while fifo is FULL (%t)",$time);

always @(posedge clk)
	if(re & empty)
		$display("%m WARNING: Reading while fifo is EMPTY (%t)",$time);


endmodule



`line 1 "C:\simulation_bench_mark\usb11\generic_fifos\generic_fifos\rtl\verilog\generic_fifo_sc_b.v"
































































`line 1 "C:\simulation_bench_mark\usb11\generic_fifos\generic_fifos\rtl\verilog\timescale.v"
`timescale 1ns / 100ps

`line 65 "C:\simulation_bench_mark\usb11\generic_fifos\generic_fifos\rtl\verilog\generic_fifo_sc_b.v"




















































































module generic_fifo_sc_b(clk, rst, clr, din, we, dout, re,
			full, empty, full_r, empty_r,
			full_n, empty_n, full_n_r, empty_n_r,
			level);

parameter dw=8;
parameter aw=8;
parameter n=32;
parameter max_size = 1<<aw;

input			clk, rst, clr;
input	[dw-1:0]	din;
input			we;
output	[dw-1:0]	dout;
input			re;
output			full, full_r;
output			empty, empty_r;
output			full_n, full_n_r;
output			empty_n, empty_n_r;
output	[1:0]		level;






reg	[aw:0]	wp;
wire	[aw:0]	wp_pl1;
reg	[aw:0]	rp;
wire	[aw:0]	rp_pl1;
reg		full_r;
reg		empty_r;
wire	[aw:0]	diff;
reg	[aw:0]	diff_r;
reg		re_r, we_r;
wire		full_n, empty_n;
reg		full_n_r, empty_n_r;
reg	[1:0]	level;






generic_dpram  #(aw,dw) u0(
	.rclk(		clk		),
	.rrst(		!rst		),
	.rce(		1'b1		),
	.oe(		1'b1		),
	.raddr(		rp[aw-1:0]	),
	.do(		dout		),
	.wclk(		clk		),
	.wrst(		!rst		),
	.wce(		1'b1		),
	.we(		we		),
	.waddr(		wp[aw-1:0]	),
	.di(		din		)
	);






always @(posedge clk )
	if(!rst)	wp <= #1 {aw+1{1'b0}};
	else
	if(clr)		wp <= #1 {aw+1{1'b0}};
	else
	if(we)		wp <= #1 wp_pl1;

assign wp_pl1 = wp + { {aw{1'b0}}, 1'b1};

always @(posedge clk )
	if(!rst)	rp <= #1 {aw+1{1'b0}};
	else
	if(clr)		rp <= #1 {aw+1{1'b0}};
	else
	if(re)		rp <= #1 rp_pl1;

assign rp_pl1 = rp + { {aw{1'b0}}, 1'b1};






assign empty = (wp == rp);
assign full  = (wp[aw-1:0] == rp[aw-1:0]) & (wp[aw] != rp[aw]);






always @(posedge clk)
	empty_r <= #1 (wp == rp) | (re & (wp == rp_pl1));

always @(posedge clk)
	full_r <= #1 ((wp[aw-1:0] == rp[aw-1:0]) & (wp[aw] != rp[aw])) |
	(we & (wp_pl1[aw-1:0] == rp[aw-1:0]) & (wp_pl1[aw] != rp[aw]));






assign diff = wp-rp;
assign empty_n = diff < n;
assign full_n  = !(diff < (max_size-n+1));

always @(posedge clk)
	level <= #1 {2{diff[aw]}} | diff[aw-1:aw-2];






always @(posedge clk)
	re_r <= #1 re;

always @(posedge clk)
	diff_r <= #1 diff;

always @(posedge clk)
	empty_n_r <= #1 (diff_r < n) | ((diff_r==n) & (re | re_r));

always @(posedge clk)
	we_r <= #1 we;

always @(posedge clk)
	full_n_r <= #1 (diff_r > max_size-n) | ((diff_r==max_size-n) & (we | we_r));







always @(posedge clk)
	if(we & full)
		$display("%m WARNING: Writing while fifo is FULL (%t)",$time);

always @(posedge clk)
	if(re & empty)
		$display("%m WARNING: Reading while fifo is EMPTY (%t)",$time);


endmodule



`line 1 "C:\simulation_bench_mark\usb11\generic_fifos\generic_fifos\rtl\verilog\lfsr.v"



















































`line 1 "C:\simulation_bench_mark\usb11\generic_fifos\generic_fifos\rtl\verilog\timescale.v"
`timescale 1ns / 100ps

`line 52 "C:\simulation_bench_mark\usb11\generic_fifos\generic_fifos\rtl\verilog\lfsr.v"


module lfsr (clk, ena, nReset, rst, q);

	
	
	
	parameter [3:0] TAPS   = 8;                

	
	
	
	input clk;                                 
	input ena;                                 
	input nReset;                              
	input rst;                                 

	output [TAPS:1] q;                         
	reg [TAPS:1] q;

	
	
	
	function lsb;
	   input [TAPS-1:0] q;

	   case (TAPS)
	       2: lsb = ~q[0];
	       3: lsb = q[3] ^ q[2];
	       4: lsb = q[4] ^ q[3];
	       5: lsb = q[5] ^ q[3];
	       6: lsb = q[6] ^ q[5];
	       7: lsb = q[7] ^ q[6];
	       8: lsb = q[8] ^ q[6] ^ q[5] ^ q[4];
	       9: lsb = q[9] ^ q[5];
	      10: lsb = q[10] ^ q[7];
	      11: lsb = q[11] ^ q[9];
	      12: lsb = q[12] ^ q[6] ^ q[4] ^ q[1];
	      13: lsb = q[13] ^ q[4] ^ q[3] ^ q[1];
	      14: lsb = q[14] ^ q[5] ^ q[3] ^ q[1];
	      15: lsb = q[15] ^ q[14];
	      16: lsb = q[16] ^ q[15] ^ q[13] ^ q[4];
	   endcase
	endfunction

	always @(posedge clk or negedge nReset)
	  if (~nReset)	q <= #1 0;
	  else if (rst)	q <= #1 0;
	  else if (ena)	q <= #1 {q[TAPS-1:1], lsb(q)};
endmodule



`line 1 "C:\simulation_bench_mark\usb11\generic_fifos\generic_fifos\rtl\verilog\generic_fifo_dc.v"
































































`line 1 "C:\simulation_bench_mark\usb11\generic_fifos\generic_fifos\rtl\verilog\timescale.v"
`timescale 1ns / 100ps

`line 65 "C:\simulation_bench_mark\usb11\generic_fifos\generic_fifos\rtl\verilog\generic_fifo_dc.v"









































































module generic_fifo_dc(rd_clk, wr_clk, rst, clr, din, we, dout, re,
			full, empty, full_n, empty_n, level );

parameter dw=8;
parameter aw=8;
parameter n=32;
parameter max_size = 1<<aw;

input			rd_clk, wr_clk, rst, clr;
input	[dw-1:0]	din;
input			we;
output	[dw-1:0]	dout;
input			re;
output			full; 
output			empty;
output			full_n;
output			empty_n;
output	[1:0]		level;






reg	[aw:0]		wp;
wire	[aw:0]		wp_pl1;
reg	[aw:0]		rp;
wire	[aw:0]		rp_pl1;
reg	[aw:0]		wp_s, rp_s;
wire	[aw:0]		diff;
reg	[aw:0]		diff_r1, diff_r2;
reg			re_r, we_r;
reg			full, empty, full_n, empty_n;
reg	[1:0]		level;






generic_dpram  #(aw,dw) u0(
	.rclk(		rd_clk		),
	.rrst(		!rst		),
	.rce(		1'b1		),
	.oe(		1'b1		),
	.raddr(		rp[aw-1:0]	),
	.do(		dout		),
	.wclk(		wr_clk		),
	.wrst(		!rst		),
	.wce(		1'b1		),
	.we(		we		),
	.waddr(		wp[aw-1:0]	),
	.di(		din		)
	);






always @(posedge wr_clk )
	if(!rst)	wp <= #1 {aw+1{1'b0}};
	else
	if(clr)		wp <= #1 {aw+1{1'b0}};
	else
	if(we)		wp <= #1 wp_pl1;

assign wp_pl1 = wp + { {aw{1'b0}}, 1'b1};

always @(posedge rd_clk )
	if(!rst)	rp <= #1 {aw+1{1'b0}};
	else
	if(clr)		rp <= #1 {aw+1{1'b0}};
	else
	if(re)		rp <= #1 rp_pl1;

assign rp_pl1 = rp + { {aw{1'b0}}, 1'b1};







always @(posedge rd_clk)	wp_s <= #1 wp;


always @(posedge wr_clk)	rp_s <= #1 rp;






always @(posedge rd_clk)
	empty <= #1 (wp_s == rp) | (re & (wp_s == rp_pl1));

always @(posedge wr_clk)
	full <= #1 ((wp[aw-1:0] == rp_s[aw-1:0]) & (wp[aw] != rp_s[aw])) |
	(we & (wp_pl1[aw-1:0] == rp_s[aw-1:0]) & (wp_pl1[aw] != rp_s[aw]));






assign diff = wp-rp;

always @(posedge rd_clk)
	re_r <= #1 re;

always @(posedge rd_clk)
	diff_r1 <= #1 diff;

always @(posedge rd_clk)
	empty_n <= #1 (diff_r1 < n) | ((diff_r1==n) & (re | re_r));

always @(posedge wr_clk)
	we_r <= #1 we;

always @(posedge wr_clk)
	diff_r2 <= #1 diff;

always @(posedge wr_clk)
	full_n <= #1 (diff_r2 > max_size-n) | ((diff_r2==max_size-n) & (we | we_r));

always @(posedge wr_clk)
	level <= #1 {2{diff[aw]}} | diff[aw-1:aw-2];








always @(posedge wr_clk)
	if(we & full)
		$display("%m WARNING: Writing while fifo is FULL (%t)",$time);

always @(posedge rd_clk)
	if(re & empty)
		$display("%m WARNING: Reading while fifo is EMPTY (%t)",$time);


endmodule



`line 1 "C:\simulation_bench_mark\usb11\generic_fifos\common\generic_memories\rtl\verilog\generic_dpram.v"









































































































module generic_dpram(
	
	rclk, rrst, rce, oe, raddr, do,
	wclk, wrst, wce, we, waddr, di
);

	
	
	
	parameter aw = 5;  
	parameter dw = 16; 

	
	
	
	
	input           rclk;  
	input           rrst;  
	input           rce;   
	input           oe;	   
	input  [aw-1:0] raddr; 
	output [dw-1:0] do;    

	
	input          wclk;  
	input          wrst;  
	input          wce;   
	input          we;    
	input [aw-1:0] waddr; 
	input [dw-1:0] di;    

	
	
	



































































































































































	
	
	

	
	
	
	reg	[dw-1:0]	mem [(1<<aw)-1:0]; 
	reg	[dw-1:0]	do_reg;            

	
	
	
	assign do = (oe & rce) ? do_reg : {dw{1'bz}};

	
	always @(posedge rclk)
		if (rce)
          		do_reg <= #1 (we && (waddr==raddr)) ? {dw{1'b x}} : mem[raddr];

	
	always @(posedge wclk)
		if (wce && we)
			mem[waddr] <= #1 di;


	
	
	task print_ram;
	input [aw-1:0] start;
	input [aw-1:0] finish;
	integer rnum;
  	begin
    		for (rnum=start;rnum<=finish;rnum=rnum+1)
      			$display("Addr %h = %h",rnum,mem[rnum]);
  	end
	endtask

 
 
 
 
 
 

endmodule



























































 
































































































 



